VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BSPTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Private Type BSPEntry
  offset As Long
  size As Long
End Type

Private la, TextureLoaded

Private Type BSPHeader
  'magic As String * 4
  version As Long
  entities As BSPEntry
  planes As BSPEntry
  miptex As BSPEntry
  vertices As BSPEntry
  visilist As BSPEntry
  nodes As BSPEntry
  TexInfo As BSPEntry
  faces As BSPEntry
  lightmaps As BSPEntry
  clipnodes As BSPEntry
  leaves As BSPEntry
  lFace As BSPEntry
  edges As BSPEntry
  ledges As BSPEntry
  models As BSPEntry
End Type

Private TriggerTexture As Long

Private Type EdgeType
  v1 As Integer
  v2 As Integer
End Type

Private Type IntBBox
  min(2) As Integer
  max(2) As Integer
End Type

Private Type LeafType
  type As Long
  vislist As Long
  bound As IntBBox
  face_id As Integer
  face_num As Integer
  style(3) As Byte
End Type

Private Type FaceType
  plane_id As Integer
  side As Integer
  egde_id As Long
  numedge As Integer
  texinfo_id As Integer
  typelight As Byte
  baselight As Byte
  Light(1) As Byte
  lightmap As Long
End Type

Private Type Node
  PlaneNum As Long
  Children(1) As Integer
  bbox As IntBBox
  FirstFace As Integer
  NumFaces As Integer
End Type

Private Type bbox
  min As D3DVECTOR
  max As D3DVECTOR
End Type

Private Type MipTexture
  TextureName As String * 16
  width As Long
  height As Long
  offset1 As Long
  offset2 As Long
  offset4 As Long
  offset8 As Long
End Type


Private Type Vertex3D
  x As Single
  y As Single
  z As Single
End Type

Private Type TextureInfo
  S As D3DVECTOR
  DistS As Single
  t As D3DVECTOR
  DistT As Single
  Texture_id As Long
  Animated As Long
End Type

Private Type Planetype
  normal As D3DVECTOR
  dist As Single
  type As Long
End Type

Private Type ModelType
  bound As bbox
  Origin As D3DVECTOR
  Headnode As Long
  node_id1 As Long
  node_id2 As Long
  node_id3 As Long
  numleaves As Long
  FirstFace As Long
  numface As Long
End Type

Private Type TransformedFaces
  Vertex() As D3DVERTEX
  texture As Integer
  Light As Integer
  Material As D3DMATERIAL7
End Type


Private Type BSPType
  Plane() As Planetype
  Vertex() As D3DVECTOR
  Face() As FaceType
  Node() As Node
  Edge() As EdgeType
  Leaf() As LeafType
  TexInfo() As TextureInfo
  Model() As ModelType
  lEdge() As Long
  lFace() As Integer
  FaceT() As TransformedFaces
  FrustumPlanes() As Planetype
  MipTexture() As MipTexture
  AffVis() As Long
End Type

Private BSP As BSPType
Private numplane, numedge, numledge, numface, numnode, numleaf, numtex, nummodel, numvertex, numlface
Private Tex(1000) As DirectDrawSurface7
Private Function FrustumCullBox(boxe As IntBBox) As Boolean
 Dim SphereCenter As D3DVECTOR
 SphereCenter = Vector((boxe.max(0) - boxe.min(0)) / 2, (boxe.max(1) - boxe.min(1)) / 2, (boxe.max(2) - boxe.min(2)) / 2)
 radius = Sqr((boxe.max(0) - boxe.min(0)) ^ 2 + (boxe.max(1) - boxe.min(1)) ^ 2 + (boxe.max(2) - boxe.max(2)) ^ 2)
 If Device.ComputeSphereVisibility(SphereCenter, CSng(radius)) And &HFFF000 Then
  FrustumCullBox = False
 Else
  FrustumCullBox = True
 End If
 
 '  Debug.Print "FrustumCullbox"
'  Debug.Print boxe.min(0), boxe.min(1), boxe.min(2)
'  Debug.Print boxe.max(0), boxe.max(1), boxe.max(2)
'  For i = 1 To 4
'     dot = BSP.FrustumPlanes(i).dist
'     For j = 1 To 3
'      Select Case j
'      Case 1: a = -BSP.FrustumPlanes(i).normal.x
'      Case 2: a = -BSP.FrustumPlanes(i).normal.y
'      Case 3: a = -BSP.FrustumPlanes(i).normal.z
'      End Select
'      If a > 0 Then dot = dot + a * boxe.min(j - 1) Else dot = dot + a * boxe.max(j - 1)
'     Next j
'    ' Debug.Print dot
'     If dot > 0 Then FrustumCullBox = True: Exit Function
'  Next i
End Function

Sub LoadTextures(Optional UseNumberFilename As Boolean, Optional TextureWidth As Long, Optional TextureHeight As Long)
On Error GoTo apprend

If IsMissing(UseNumberFilename) = True Then
  UseNumberFilename = False
End If
 
 For i = 0 To UBound(BSP.MipTexture) - 1
   If IsMissing(TextureWidth) Then
     TextureWidth = BSP.MipTexture(i).width
   End If
   If IsMissing(TextureHeight) Then
     TextureHeight = BSP.MipTexture(i).height
   End If
   ERrStr = "Debug 1"
   If UseNumberFilename = True Then
    ERrStr = "Use Number"
    Set Tex(i) = LoadSimpleTexture(CStr(i) + ".bmp", TextureWidth, TextureHeight)
   Else
    ERrStr = "Dont Use numbers"
    Set Tex(i) = LoadSimpleTexture(BSP.MipTexture(i).TextureName + ".bmp", TextureWidth, TextureHeight)
   End If
   If InStr(UCase(BSP.MipTexture(i).TextureName), "AAATRIGGER") Then
     ERrStr = "Trigger"
     TriggerTexture = i
   End If
   If Left(BSP.MipTexture(i).TextureName, 1) = "{" Then
      ERrStr = "Set Color Key"
      Dim ppf As DDPIXELFORMAT
      BackBuffer.GetPixelFormat ppf
      Dim ck As DDCOLORKEY
      ck.high = ppf.lBBitMask
      ck.low = ppf.lBBitMask
      'On Error Resume Next
      Tex(i).SetColorKey DDCKEY_SRCBLT, ck
      Device.SetRenderState D3DRENDERSTATE_COLORKEYBLENDENABLE, True
      Device.SetRenderState D3DRENDERSTATE_COLORKEYENABLE, True
   End If
  Next i
  TextureLoaded = True
Exit Sub

apprend:

AddLog CStr(Date) + " " + CStr(Time) + " Error in LoadTextures " + Err.Description + " " + CStr(Err.Number) + " " + CStr(i) + " " + ERrStr
Resume Next

End Sub

Private Sub ReleaseBSPTree()
  For i = 1 To 1000
   Set Tex(i) = Nothing
  Next i
  Close
  
End Sub




Sub RenderTree()
Device.SetRenderState D3DRENDERSTATE_CULLMODE, D3DCULL_NONE
   
  On Error GoTo ete
'If TextureLoaded = True Then
' For i = 0 To numface - 1
'   If BSP.FaceT(i).texture <> TriggerTexture Then
'    If anc <> BSP.FaceT(i).texture Then
'    Device.SetTexture 0, Tex(BSP.FaceT(i).texture)
'    anc = BSP.FaceT(i).texture
'    End If
'    Device.SetMaterial BSP.FaceT(i).Material
'    Device.DrawPrimitive D3DPT_TRIANGLEFAN, D3DFVF_VERTEX, BSP.FaceT(i).Vertex(0), UBound(BSP.FaceT(i).Vertex), D3DDP_DEFAULT
'   End If
' Next i
' Else
'  For i = 0 To numface - 1
'     Device.SetMaterial BSP.FaceT(i).Material
'     Device.DrawPrimitive D3DPT_TRIANGLEFAN, D3DFVF_VERTEX, BSP.FaceT(i).Vertex(0), UBound(BSP.FaceT(i).Vertex), D3DDP_DEFAULT
'  Next i
'
 'End If
   'Leaf = FindLeaf(StartPos)
   'la = la + 0.1
   'If la - 10 > numleaf Then la = 0
   SearchVisLeafs
   Dim FaceDrawn() As Integer
   ReDim FaceDrawn(UBound(BSP.FaceT))
   For l = 1 To UBound(BSP.AffVis)
     Leaf = BSP.AffVis(l)
     For i = BSP.Leaf(Leaf).face_id To BSP.Leaf(Leaf).face_num + BSP.Leaf(Leaf).face_id
      ri = BSP.lFace(i)
      If FaceDrawn(ri) = 0 Then
       FaceDrawn(ri) = 1
      If anc <> BSP.FaceT(ri).texture Then
      Device.SetTexture 0, Tex(BSP.FaceT(ri).texture)
      anc = BSP.FaceT(ri).texture
      End If
 
      Device.SetMaterial BSP.FaceT(ri).Material
      Device.DrawPrimitive D3DPT_TRIANGLEFAN, D3DFVF_VERTEX, BSP.FaceT(ri).Vertex(0), UBound(BSP.FaceT(ri).Vertex), D3DDP_DEFAULT
      End If
     Next i
   Next l
  'Str = "Planes"
'  TransformPlanes ViewMatrix, StartPos
  'Str = "Search"
  BackBuffer.DrawText 0, 40, CStr(Leaf) + " " + CStr(UBound(BSP.AffVis)), False
  
 
 Exit Sub
ete:
 AddLog CStr(Date) + " " + CStr(Time) + " Error in RenderTree:" + Err.Description + " " + CStr(Err.Number)
 Resume Next
End Sub

Private Sub SearchVisLeafs()
 ReDim BSP.AffVis(0)
 WalkTree 0
End Sub

Public Sub TransformFaces()
  On Error GoTo errtra
  Dim v1 As D3DVECTOR, v2 As D3DVECTOR
  ReDim Preserve BSP.FaceT(numface)
  Debug.Print numedge
  

  
  For i = 0 To numface - 1
    With BSP.Face(i)
      nedge = .egde_id
      nbedge = .numedge
      'Debug.Print "Faces :"; i; " Edge id :"; .egde_id, " Edge num "; .numedge
       ReDim BSP.FaceT(i).Vertex(.numedge)
      For r = 0 To nbedge - 1
       edge_i = nedge + r
       edge_i = BSP.lEdge(edge_i)
       
       If edge_i < 0 Then
        v1 = BSP.Vertex(BSP.Edge(-edge_i).v2)
       Else
        v1 = BSP.Vertex(BSP.Edge(edge_i).v1)
       End If
       s1 = 1 / BSP.MipTexture(BSP.TexInfo(.texinfo_id).Texture_id).width
        t1 = 1 / BSP.MipTexture(BSP.TexInfo(.texinfo_id).Texture_id).height
       'Debug.Print BSP.TexInfo(i).Texture_id
         S = DirectX.VectorDotProduct(v1, BSP.TexInfo(.texinfo_id).S) + BSP.TexInfo(.texinfo_id).DistS
         t = DirectX.VectorDotProduct(v1, BSP.TexInfo(.texinfo_id).t) + BSP.TexInfo(.texinfo_id).DistT
         '  Debug.Print Asc(CStr(BSP.Leaf(i).style))
            
           ' s=FVec_DotProduct(v,texinfo->vecs[0])+texinfo->vecs[0][3];
           ' t=FVec_DotProduct(v,texinfo->vecs[1])+texinfo->vecs[1][3];
           ' myface->verts[i].s=s*is;
           ' myface->verts[i].t=t*it;

        BSP.FaceT(i).Vertex(r) = Vertex(v1.x, v1.y, v1.z, 0, 0, 1, S * s1, t * t1)
    '   AddLog "Vertex " + CStr(r) + " Face " + CStr(i) + " TC: " + CStr(S) + " " + CStr(s1)
       
        
      Next r
      
        BSP.FaceT(i).texture = BSP.TexInfo(.texinfo_id).Texture_id
        'Debug.Print BSP.FaceT(i).Texture, .texinfo_id
    BSP.FaceT(i).Material.Ambient = DXColor(.Light(0) / 255, .Light(0) / 255, .Light(0) / 255, 1)
    End With

  Next i
  Exit Sub
errtra:
  AddLog "Error Transform Face " + CStr(Err.Number) + " " + Err.Description
End Sub



Private Function FindLeaf(coord As D3DVECTOR) As Integer
 Dim nodea As Node
 Dim planea As Planetype
 Dim idx As Long
 Dim dot As Single
 
 idx = BSP.Model(0).Headnode
 
 Do
  nodea = BSP.Node(idx)
  planea = BSP.Plane(nodea.PlaneNum)
  dot = DirectX.VectorDotProduct(planea.normal, coord) - planea.dist
  If dot >= 0 Then idx = nodea.Children(0) Else idx = nodea.Children(1)
 
 
 Loop While idx >= 0

 FindLeaf = -(idx + 1)
 'Debug.Print idx
End Function


Sub Load(filename)
On Error GoTo GestError
  Dim BSPH As BSPHeader
  Open filename For Binary Lock Read As 1
    Get #1, 1, BSPH
    
    numvertex = BSPH.vertices.size / Len(BSP.Vertex(1))
    ReDim Preserve BSP.Vertex(numvertex)
    Get #1, BSPH.vertices.offset + 1, BSP.Vertex()

    numplane = BSPH.planes.size / Len(BSP.Plane(1))
    ReDim Preserve BSP.Plane(numplane)
    Get #1, BSPH.planes.offset + 1, BSP.Plane()
    
    numface = BSPH.faces.size / Len(BSP.Face(1))
    ReDim Preserve BSP.Face(numface)
    Get #1, BSPH.faces.offset + 1, BSP.Face()
   
    numnode = BSPH.nodes.size / Len(BSP.Node(1))
    ReDim Preserve BSP.Node(numnode)
    Get #1, BSPH.nodes.offset + 1, BSP.Node()
   
    numedge = BSPH.edges.size / Len(BSP.Edge(1))
    ReDim Preserve BSP.Edge(numedge)
    Get #1, BSPH.edges.offset + 1, BSP.Edge()
   
    numleaf = BSPH.leaves.size / Len(BSP.Leaf(1))
    ReDim Preserve BSP.Leaf(numleaf)
    Get #1, BSPH.leaves.offset + 1, BSP.Leaf()
   
    numtex = BSPH.TexInfo.size / Len(BSP.TexInfo(1))
    ReDim Preserve BSP.TexInfo(numtex)
    Get #1, BSPH.TexInfo.offset + 1, BSP.TexInfo()
    
    numledge = BSPH.ledges.size / Len(BSP.lEdge(1))
    ReDim Preserve BSP.lEdge(numledge)
    Get #1, BSPH.ledges.offset + 1, BSP.lEdge()
    
     nummodel = BSPH.models.size / Len(BSP.Model(1))
    ReDim Preserve BSP.Model(nummodel)
    Get #1, BSPH.models.offset + 1, BSP.Model()
    
    numlface = BSPH.lFace.size / Len(BSP.lFace(1))
    ReDim Preserve BSP.lFace(numlface)
    Get #1, BSPH.lFace.offset + 1, BSP.lFace()
    
    Dim offset() As Long
    Dim NumMip As Long
    Get #1, BSPH.miptex.offset + 1, NumMip
    
    ReDim Preserve offset(NumMip)
    Get #1, , offset()
    Debug.Print "Mip texture :"; NumMip
    ReDim Preserve BSP.MipTexture(NumMip)
    For i = 0 To NumMip - 1
     Get #1, BSPH.miptex.offset + 1 + offset(i), BSP.MipTexture(i)
    
     'Remove Chr(0)
     escchr = InStr(BSP.MipTexture(i).TextureName, Chr(0))
     BSP.MipTexture(i).TextureName = Left(BSP.MipTexture(i).TextureName, escchr - 1)
   
    ' Debug.Print offset(i), BSP.MipTexture(i).TextureName
     
    Next i
 
    
    
  ' AddLog CStr(BSPH.TexInfo.offset) + " " + CStr(BSPH.TexInfo.size)
   ' Debug.Print BSPH.miptex.offset, BSPH.miptex.size
   Close #1
  ' DirectX.IdentityMatrix CameraMatrix
  ' Debug.Print "Plane :"; numleaf
  ' Debug.Print BSP.Model(0).bound.max.x, BSP.Model(0).bound.max.y, BSP.Model(0).bound.max.z
'  For i = 0 To numnode - 1
'    Debug.Print BSP.Node(i).min(0), BSP.Node(i).min(1), BSP.Node(i).min(2)
'    Debug.Print BSP.Node(i).max(0), BSP.Node(i).max(1), BSP.Node(i).max(2)
'
'  Next i
'
Exit Sub
GestError:
  AddLog "Error in TrueVision7::BSPTree Load " + Err.Description + " " + CStr(Err.Number)
Resume Next


End Sub

Private Sub TransformPlanes(RotMat As D3DMATRIX, Camera As D3DVECTOR)
 ReDim BSP.FrustumPlanes(5)
 c = Cos(FOV / 2)
 S = Sin(FOV / 2)
'Debug.Print "TransPlane "; c, S

 
 With BSP.FrustumPlanes(1)
 Dim normal As D3DVECTOR
 normal = Vector(-c, 0, -S)
 .normal = VectorXMatrix(RotMat, normal)
 .dist = DirectX.VectorDotProduct(normal, Camera)
 Debug.Print .normal.x, .normal.y, .normal.z
 
 End With
 
 With BSP.FrustumPlanes(2)
 normal = Vector(c, 0, -S)
 .normal = VectorXMatrix(RotMat, normal)
 .dist = DirectX.VectorDotProduct(normal, Camera)
 Debug.Print .normal.x, .normal.y, .normal.z
 
 End With
 
With BSP.FrustumPlanes(3)
 normal = Vector(0, -c, -S)
 .normal = VectorXMatrix(RotMat, normal)
 .dist = DirectX.VectorDotProduct(normal, Camera)
 Debug.Print .normal.x, .normal.y, .normal.z
 
 End With
 
With BSP.FrustumPlanes(4)
 normal = Vector(0, c, -S)
 .normal = VectorXMatrix(RotMat, normal)
 .dist = DirectX.VectorDotProduct(normal, Camera)
 Debug.Print .normal.x, .normal.y, .normal.z
 
End With
 
 
End Sub

Private Function Vector(x, y, z) As D3DVECTOR
  Vector.x = x
  Vector.y = y
  Vector.z = z
End Function


Private Function VectorXMatrix(mat As D3DMATRIX, Vector As D3DVECTOR) As D3DVECTOR
        VectorXMatrix.x = mat.rc11 * Vector.x + mat.rc12 * Vector.y + mat.rc13 * Vector.z
        VectorXMatrix.y = mat.rc21 * Vector.x + mat.rc22 * Vector.y + mat.rc23 * Vector.z
        VectorXMatrix.z = mat.rc31 * Vector.x + mat.rc32 * Vector.y + mat.rc33 * Vector.z

  'Vector (5,10,5)
  'Matrix
  ' 1 0 0 0
  ' 0 1 0 0
  ' 0 0 1 0
  ' 0 0 0 1
  

End Function


Private Function WalkTree(NodeIndex As Integer)
  'Debug.Print "WalkTree "; NodeIndex
  If NodeIndex < 0 Then
    Leaf = -(NodeIndex + 1)
    ReDim Preserve BSP.AffVis(UBound(BSP.AffVis) + 1)
    BSP.AffVis(UBound(BSP.AffVis)) = Leaf
    
   Exit Function
  End If
  If FrustumCullBox(BSP.Node(NodeIndex).bbox) = True Then
     e = WalkTree(BSP.Node(NodeIndex).Children(0))
     e = WalkTree(BSP.Node(NodeIndex).Children(1))
  End If
End Function

Private Sub Class_Terminate()
 ReleaseBSPTree
End Sub


