VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Camera"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------
'****************
' TrueVision 0.9
'****************
'----------------
'  Camera class
'----------------
' by ~ Sylvain Dupont ~
'
' 03-06-2000 : Two bugs fixed
' 28-06-2000 : Creation

Private EyeHeight As Single





'*******************************
'*******************************
Function CheckPointVisibility(PointX, PointY, PointZ) As Boolean
 If Device.ComputeSphereVisibility(Vector(PointX, PointY, PointZ), 1) And &HFFF000 Then
  CheckPointVisibility = False
 Else
  CheckPointVisibility = True
 End If
End Function
Function CheckSphereVisibility(CenterX, CenterY, CenterZ, radius) As Boolean
  If Device.ComputeSphereVisibility(Vector(CenterX, CenterY, CenterZ), CSng(radius)) And &HFFF000 Then
  CheckSphereVisibility = False
 Else
  CheckSphereVisibility = True
 End If

End Function

Function GetCameraLookAt() As D3DVECTOR
  GetCameraLookAt = EndPos
End Function
Function GetCameraPosition() As D3DVECTOR
  GetCameraPosition = StartPos
End Function
Function GetCameraRotationX() As Single
  GetCameraRotationX = GetCameraAngleX
End Function
Function GetCameraRotationY() As Single
   GetCameraRotationY = GetCameraAngle
End Function
Sub LookAtMesh(Mesh As Mesh)
  ind = Mesh.GetMeshIndex
  SetCameraLookAt Mesh.GetPosition.x, Mesh.GetPosition.y, Mesh.GetPosition.z
End Sub
Sub MoveForward(StepPerSecond As Single, Optional FollowLandscapeAltitude As Boolean, Optional DontMoveYAxis As Boolean)
 Dim Step As Single
 Step = StepPerSecond * SystemFrame / 1000
 Dim DN As D3DVECTOR, DNA As D3DVECTOR
  DN = VNormalize(VSubtract(EndPos, StartPos))
  DNA = DN
  If FollowLandscapeAltitude Or DontMoveYAxis Then
    DNA.y = 0
    DNA = VNormalize(DN)
  End If

  StartPos = VAdd(StartPos, VScale(DNA, Step))
  If FollowLandscapeAltitude = True Then
   StartPos.y = GetHeightModule(StartPos.x, StartPos.z) + EyeHeight
  End If
  EndPos = VAdd(StartPos, VScale(DN, Step))
  DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
End Sub

Sub SetCameraRotation(DegreesX As Single, DegreesY As Single)
  SetCameraLookAt StartPos.x + Cos(DegreesX * 3.1415 / 180), StartPos.y + Sin(DegreesY * 3.1415 / 180), StartPos.z + Sin(DegreesX * 3.1415 / 180)
End Sub

Sub RotateAroundMesh(DestMesh As Mesh, AddMeshRotation As Boolean, DegreesAngle As Single, Optional Distance As Single, Optional CameraRelativeAltitude As Single)
  If Distance = 0 Then
    'use camera-mesh distance
    Dim D As D3DVECTOR
    D = VSubtract(DestMesh.GetPosition, StartPos)
    Distance = Sqr(D.x ^ 2 + D.y ^ 2 + D.z ^ 2)
  End If
  If AddMeshRotation = True Then
    angle = DestMesh.GetRotation.y + DegreesAngle
  Else
    angle = DegreesAngle
  End If
  
  EndPos = DestMesh.GetPosition
  StartPos = VAdd(DestMesh.GetPosition, Vector(Cos(angle) * Distance, CameraRelativeAltitude, Sin(angle) * Distance))
  DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
End Sub
Sub SetCamera(PosX, PosY, PosZ, LookAtX, LookAtY, LookAtZ)
 StartPos = Vector(PosX, PosY, PosZ)
 EndPos = Vector(LookAtX, LookAtY, LookAtZ)
  DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
End Sub


Sub SetCameraLookAt(x As Single, y As Single, z As Single)
 EndPos = Vector(x, y, z)
  DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
  
End Sub
'----------------------------------------------
' Wrapper for General module : StartPos, EndPos
'----------------------------------------------

Sub SetCameraPosition(x As Single, y As Single, z As Single)
  StartPos = Vector(x, y, z)
End Sub

Sub SetPlayerEyeHeight(height As Single)
   EyeHeight = height
End Sub


Private Sub Class_Initialize()
  EyeHeight = 10
End Sub


