VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Console"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Public Enum EnumConsoleMode
 TV_FULLSCREEN = 1
 TV_BOTTOM = 2
 TV_TOP = 3
End Enum

Private ConsoleWidth, ConsoleHeight, Mode As EnumConsoleMode
Private TextLine(100) As String, NBLineMax As Integer
Private TextColor(100) As Long, TH As Single
Private FontName As String, FontSize As Single, LigneCourante, FontBold As Boolean
Public LastCommand As String
Private UseTvCommand As Boolean



Private Sub ApplyCommand()
   p1 = Val(GetParameter(1))
   p2 = Val(GetParameter(2))
   p3 = Val(GetParameter(3))
  Select Case GetKeyword
    Case "SETCONSOLE"
      If GetParameter(1) = "" Or Val(GetParameter(1)) < 1 Or Val(GetParameter(1)) > 3 Then
        WriteConsole "Wrong Command : Argument missing", RGB(256, 0, 0)
        WriteConsole "SETCONSOLE consoletype [y-ratio]", RGB(0, 256, 0)
        WriteConsole "  consoletype :", RGB(0, 256, 0)
        WriteConsole "    1:fullscreen 2:top 3:bottom  ", RGB(0, 256, 0)
      Else
       Dim ratio As Single
       If Val(GetParameter(2)) > 0 Then
        ratio = Val(GetParameter(2))
       Else
        ratio = 0.4
       End If
       InitConsole Val(GetParameter(1)), ratio
      End If
     Case "SETFOV"
      If Val(GetParameter(1)) = 0 Then
        WriteConsole "Wrong Command : Argument missing or incorrect", RGB(256, 0, 0)
        WriteConsole "SETFOV degreesfovangle", RGB(0, 256, 0)
      Else
         FOV = Val(GetParameter(1))
         DirectX.ProjectionMatrix ProjectionMatrix, 1, FarPlane, FOV * 3.141592 / 180
         device.SetTransform D3DTRANSFORMSTATE_PROJECTION, ProjectionMatrix
      End If
     Case "GETFPS"
      WriteConsole "Current FPS : " + CStr(FPS), RGB(0, 256, 0)
     Case "SETFARPLANE"
       If Val(GetParameter(1)) = 0 Then
        WriteConsole "Wrong Command : Argument missing or incorrect", RGB(256, 0, 0)
        WriteConsole "SETFARPLANE farplane", RGB(0, 256, 0)
      Else
         FarPlane = Val(GetParameter(1))
         DirectX.ProjectionMatrix ProjectionMatrix, 1, FarPlane, FOV * 3.141592 / 180
         device.SetTransform D3DTRANSFORMSTATE_PROJECTION, ProjectionMatrix
      End If
     Case "SETCAMERAPOS"
      If Val(GetParameter(1)) = 0 Or Val(GetParameter(2)) = 0 Or Val(GetParameter(3)) = 0 Then
         WriteConsole "Wrong Command : Argument missing or incorrect", RGB(256, 0, 0)
         WriteConsole "SETCAMERAPOS xpos ypos zpos", RGB(0, 256, 0)
      Else
        StartPos = Vector(Val(GetParameter(1)), Val(GetParameter(2)), Val(GetParameter(3)))
        DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
      End If
     Case "SETBACK", "SETBACKGROUND", "SETBACKCOLOR", "SETBACKGROUNDCOLOR"
       BackGround = DirectX.CreateColorRGBA(p1, p2, p3, 1)
     Case "VER", "VERSION", "GETVERSION"
       WriteConsole "TrueVision v0.81 Console", RGB(256, 256, 0)
       WriteConsole "CDVG  Copyright 2000 - Engine by Sylvain Dupont", RGB(0, 256, 0)
    
     End Select
End Sub

Sub Clear()
 For i = 1 To NBLineMax
   TextLine(i) = ""
 Next i
 LigneCourante = 0
End Sub

Public Sub DoConsole()
 KeyConsole = 0
  WriteConsole ">", 16777215
  Do
   DoEvents
   If KeyConsole >= 32 And KeyConsole < 255 Then
    texti = texti + Chr(KeyConsole)
    KeyConsole = 0
   End If
   If KeyConsole = 8 Then
    If Len(texti) > 1 Then
     texti = Left(texti, Len(texti) - 1)
    Else
     texti = ""
    End If
   
   End If
    KeyConsole = 0
   TextLine(LigneCourante) = ">" + texti
   RenderConsole
   FlipToScreen
  Loop Until KeyConsole = 27 Or KeyConsole = 13
  If KeyConsole = 27 Then LastCommand = "EXIT"
  If KeyConsole = 13 Then LastCommand = texti

  If UseTvCommand = True Then ApplyCommand
  KeyConsole = 0
End Sub
Function GetParameter(paramIndex As Integer) As String
    On Local Error GoTo GestError
      
     'search the first space
   lst = UCase(Trim(LastCommand))
   If lst = "" Then Exit Function
  
   
   lstleft = lst
   For i = 1 To paramIndex
   sp = InStr(lstleft, " ")
   If sp = 0 Then GetParameter = "": Exit Function
   lstleft = Mid(lstleft, sp + 1)
   Next
   
   sp = InStr(lstleft, " ")
   If sp > 0 Then lstleft = Left(lstleft, sp - 1)
   GetParameter = lstleft
      
    Exit Function
GestError:
     WriteConsole "Can't read the parameter " + CStr(paramIndex), RGB(256, 0, 0)
     Err.Clear

End Function

Function GetKeyword() As String
  'search the keyword in the console command
  ' ==> first word
  
  lst = UCase(Trim(LastCommand))
  If lst = "" Then Exit Function
  
  sp = InStr(lst, " ")
  If sp = 0 Then GetKeyword = lst: Exit Function
  GetKeyword = Left(lst, sp - 1)
End Function
Private Sub GetLineMax()
  Form1.FontName = FontName
  Form1.FontSize = FontSize
  Form1.FontBold = FontBold
  TH = Form1.TextHeight("AZER") + 1
  NBLineMax = Int(ConsoleHeight / TH)
  Console.SetFont Form1.Font
  
End Sub


Sub InitConsole(ConsoleMode As EnumConsoleMode, Optional RatioY As Single = 0.4)
 On Error GoTo GestEr
 Set Console = Nothing
 Dim ddsd As DDSURFACEDESC2

  ddsd.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
    ddsd.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
    AddLog "Console init :" + CStr(ConsoleMode) + " " + CStr(RatioY)
 If ConsoleMode = TV_TOP Or ConsoleMode = TV_BOTTOM Then
  ddsd.lWidth = BBDDSD.lWidth
  ddsd.lHeight = BBDDSD.lHeight * RatioY
 Else
  ddsd.lWidth = BBDDSD.lWidth
  ddsd.lHeight = BBDDSD.lHeight

 End If
 
 ConsoleWidth = ddsd.lWidth
 ConsoleHeight = ddsd.lHeight
 Mode = ConsoleMode
 Set Console = DD.CreateSurface(ddsd)
 Console.BltColorFill REC(0, 0, 0, 0), 0
 GetLineMax
 LigneCourante = 0
 AddLog "Console initialized"
Exit Sub
GestEr:
AddLog "Error in InitConsole :" + Err.Description + " " + CStr(Err.Number)
Resume Next
End Sub
Public Sub SetFont(Name As String, size As Single, Optional Bold As Boolean = True)
 FontName = Name
 FontSize = size
 FontBold = Bold
 GetLineMax
End Sub


Public Property Get UseStandardTVCommand() As Boolean
  UseStandardTVCommand = UseTvCommand
End Property

Public Property Let UseStandardTVCommand(bool As Boolean)
  UseTvCommand = bool
End Property

Sub WriteConsole(Text As String, Optional Color As Long = 16777215)
LigneCourante = LigneCourante + 1
If LigneCourante > NBLineMax Then
  LigneCourante = NBLineMax
  For i = 1 To LigneCourante Step 1
    TextLine(i - 1) = TextLine(i)
    TextColor(i - 1) = TextColor(i)
  Next i
End If
TextLine(LigneCourante) = Text
TextColor(LigneCourante) = Color
RenderConsole
End Sub

Public Sub RenderConsole()
 On Error GoTo GestEr
 ERrStr = "BltColorFill"
 Console.BltColorFill REC(0, 0, 0, 0), 0
 ERrStr = "Write Line"
 For i = 1 To LigneCourante
   ERrStr = "ForeColor " + CStr(i)
   Console.SetForeColor TextColor(i)
   ERrStr = "DrawText " + CStr(i)
   If TextLine(i) <> "" Then
   Console.DrawText 5, i * TH - TH + 2, TextLine(i), False
   End If
 Next i
 If Mode = TV_FULLSCREEN Or Mode = TV_TOP Then y = 0 Else y = BBDDSD.lHeight - ConsoleHeight
 BackBuffer.BltFast 0, y, Console, REC(0, 0, 0, 0), DDBLTFAST_WAIT
 Exit Sub
GestEr:
AddLog "Error in RenderConsole " + ERrStr + " " + Err.Description + " " + CStr(Err.Number)
Resume Next
End Sub

Private Sub Class_Initialize()
 FontSize = 10
 FontName = "Arial"
 FontBold = True
 LigneCourante = 0
 UseTvCommand = True
End Sub


Private Sub Class_Terminate()
 Set Console = Nothing
End Sub


