Attribute VB_Name = "LandscapeModule"
' TrueVision engine v.9
' Landscape engine v.01
'
'Landscape class is a wrapper for this module


' 02-07-2000 : Sun & Cloud & Ambient Light
' 28-06-2000 : Water (alpha & alpha factor) bug fixed

Public HeightSurface As DirectDrawSurface7

Public Type WaterEffect
 Altitude As Single
 Alphablended As Boolean
 AlphaFactor As Single
 DestBlend As Long
 SrcBlend As Long
 Enabled As Boolean
 texture As Integer
 Animated As Boolean
 AnimKey As Single
 TextureScale As Single
 Vertex(4) As D3DLVERTEX
End Type

Public Type PartTerrain
 texture As Integer
 Sphere As D3DVECTOR
 radius As Single
 Index() As Integer
 Index2() As Integer
 Index3() As Integer
 Enabled As Boolean
End Type

Public Type CloudLayer
  Material As Integer
  texture As Integer
  CVertex(4) As D3DVERTEX
End Type

Public Type LandScapeDay
 SunVertex(4) As D3DVERTEX
 SunMaterial As Integer
 Layers() As CloudLayer
 CloudFlags As Integer
 TimeDay As Single
 LandscapeCloud As Boolean
 LandscapeSun As Boolean
 SunPosition As D3DVECTOR
 SunTexture As Integer
End Type

Public Type LandScape
 Vertex() As D3DVERTEX
 Terrain() As PartTerrain
 Water As WaterEffect
 DayFX As LandScapeDay
 width As Long
 height As Long
 MaxVertexX As Long
 MaxVertexY As Long
 TerrainV As Long
 Precision As Long
 Material As Integer
 TerrainYFactor As Single
 DegradationZ As Single
End Type

Public Land As LandScape
Public WhetherBS As New BillboardSystem

Public LandscapeRain As Boolean

Sub GenerateNormalsModule()
 Dim Edge1 As D3DVECTOR, Edge2 As D3DVECTOR
 Dim Cross As D3DVECTOR
 
 MaxX = Land.MaxVertexX
 MaxY = Land.MaxVertexY
 
 For lY = 0 To MaxY - 2
   For lX = 0 To MaxX - 2
     Edge1 = VSubtract(verte(Land.Vertex(MaxX * lY + lX + 1)), verte(Land.Vertex(MaxX * lY + lX)))
     Edge2 = VSubtract(verte(Land.Vertex(MaxX * (lY + 1) + lX)), verte(Land.Vertex(MaxX * lY + lX)))
     DirectX.VectorCrossProduct Cross, Edge1, Edge2
     Land.Vertex(MaxX * lY + lX).nx = Cross.x
     Land.Vertex(MaxX * lY + lX).ny = Cross.y
     Land.Vertex(MaxX * lY + lX).nz = Cross.z
   Next lX
  Next lY
End Sub

Public Function GetHeightModule(x, z)
  'still a great accurate thing !
 
  Dim t As Double, U As Double, v As Double, t1 As Double, u1 As Double, v1 As Double
  Dim dest As D3DVECTOR
  Dim Origin As D3DVECTOR
   
   'calculate the ray direction (bottom --> top)
   Origin = Vector(x, 0, z)
   dest = Vector(0, 1, 0)

    DirectX.VectorNormalize dest
    
    'compute the position of the player on the terrain
    xpos = Int((Origin.x - 0) / Land.Precision)
    ypos = Int((Origin.z - 0) / Land.Precision)
   
   On Error Resume Next
   For xq = xpos - 1 To xpos + 1
    For yq = ypos - 1 To ypos + 1
     If yq >= 0 And yq < Land.MaxVertexY And xq >= 0 And xq < Land.MaxVertexX Then
     'select good vertexes
     v3 = yq * Land.MaxVertexX + xq
     v2 = (yq + 1) * Land.MaxVertexX + xq
     v1 = (yq + 1) * Land.MaxVertexX + xq + 1
     v6 = yq * Land.MaxVertexX + xq
     v5 = (yq + 1) * Land.MaxVertexX + xq + 1
     v4 = yq * Land.MaxVertexX + xq + 1
     
     g = Ray_Tri(Origin, dest, verte(Land.Vertex(v1)), verte(Land.Vertex(v2)), verte(Land.Vertex(v3)), t, U, v)
     g1 = Ray_Tri(Origin, dest, verte(Land.Vertex(v4)), verte(Land.Vertex(v5)), verte(Land.Vertex(v6)), t1, u1, v1)
     
     If (g = 1 And t >= 0) Or (g1 = 1 And t1 >= 0) Then
     'if we have a collision (I hope we'll have a collision else we'll a big problem : GetHeight = 00)
     If t = 0 Then GetHeightModule = t1 Else GetHeightModule = t
     Exit Function
    End If
   End If
    Next yq
   Next xq
End Function
Sub CreateLandscapeModule(w As Integer, h As Integer)
 Land.width = w
 Land.height = h
 
 'compute the terrain count
 NumberTerrain = w * h
 If NumberTerrain <= 0 Then Exit Sub
 
 ReDim Land.Terrain(NumberTerrain)
 
 'compute the vertexes count (it might be very very great..)
 NumberVertexesPerTerrain = (256 / Land.Precision) ^ 2
 NumberVertexes = NumberTerrain * NumberVertexesPerTerrain
 AddLog "NumberVertexes " + CStr(NumberVertexes)
 
 ReDim Land.Vertex(NumberVertexes)

  'Terrain repartition (4x3)
  '------------------------
  '!    !     !     !     !
  '! 1  !  2  !  3  !  4  !
  '!    !     !     !     !
  '------------------------
  '!    !     !     !     !
  '! 5  !  6  !  7  !  8  !
  '!    !     !     !     !
  '------------------------
  '!    !     !     !     !
  '! 9  ! 10  ! 11  ! 12  !
  '!    !     !     !     !
  '------------------------
  
  'create vertexes x,z,tu,tv,nx,ny,nz (y comes later)
  'with  texture coordinates (1,1)
  MaxX = w * (256 / Land.Precision)
  MaxY = h * (256 / Land.Precision)
  AddLog "maxx " + CStr(MaxX) + " maxy " + CStr(MaxY)
  For lY = 0 To MaxY - 1
   For lX = 0 To MaxX - 1
     With Land.Vertex(MaxX * lY + lX)
       .x = lX * Land.Precision
       .z = lY * Land.Precision
       .nx = 0
       .ny = 1
       .nz = 0
       .tu = (lX / MaxX) * w - (Int((lX / MaxX) * w) * 0.999)
       .tv = (lY / MaxY) * h - (Int((lY / MaxY) * h) * 0.999)

     End With
     
   Next lX
  Next lY
  AddLog "Vertexes"
  Land.MaxVertexX = MaxX
  Land.MaxVertexY = MaxY
  Land.TerrainV = 256 / Land.Precision
 '
 ' Compute terrain sphere
 '
 For y = 0 To h - 1
  For x = 0 To w - 1
    With Land.Terrain(y * w + x + 1)
      .Sphere = Vector(x * 256 + 128, 0, y * 256 + 128)
      .radius = 128 * Sqr(2)
    End With
  Next x
 Next y
     'create water
  With Land.Water
   .Vertex(2) = LVertex(0, 0, 0, DirectX.CreateColorRGBA(1, 1, 1, 1), 0, 32)
   .Vertex(1) = LVertex(Land.width * 256, 0, 0, DirectX.CreateColorRGBA(1, 1, 1, 1), 32, 32)
   .Vertex(4) = LVertex(0, 0, Land.height * 256, DirectX.CreateColorRGBA(1, 1, 1, 1), 0, 0)
   .Vertex(3) = LVertex(Land.width * 256, 0, Land.height * 256, DirectX.CreateColorRGBA(1, 1, 1, 1), 32, 0)
  End With
    Land.Water.Altitude = 0
    Land.Water.AnimKey = 0
    Land.Water.TextureScale = 32
    Land.Water.SrcBlend = D3DBLEND_SRCALPHA
    Land.Water.DestBlend = D3DBLEND_ONE
 Land.DegradationZ = 512
 
End Sub
Sub LoadPartTerrainModule(HeightMapFile As String, PosX As Integer, PosY As Integer, YFactor As Single)
    Dim EmptyRect As RECT, ddsd As DDSURFACEDESC2
    Dim ddsdH As DDSURFACEDESC2
    
    Precision = Land.Precision
    mapx = 256 / Precision
    mapy = 256 / Precision
    
    Set HeightSurface = Nothing
    TestPAKFile HeightMapFile
    Set HeightSurface = CreateSurfaceFromFile(HeightMapFile, ddsdH)
    DeletePAKTemp HeightMapFile
     
    px = PosX
    py = PosY
    numTerrain = py * Land.width + px + 1
    
    'get altitude
    With HeightSurface
          .Lock EmptyRect, ddsd, DDLOCK_WAIT, 0
           For x = 0 To mapx - 1
              For y = 0 To mapy - 1
                alt = (.GetLockedPixel(x * Precision, y * Precision)) / 256
                Land.Vertex((py * Land.TerrainV + y) * Land.MaxVertexX + px * Land.TerrainV + x).y = alt * Land.TerrainYFactor
              Next y
           Next x
          .Unlock EmptyRect
    End With
    
    'create indexes ! Normal Quality
    With Land.Terrain(numTerrain)
      ReDim .Index(mapx * mapy * 6)
      i = 0
      For y = 0 To mapy - 1
        For x = 0 To mapx - 1
         If (PosX = Land.width - 1 And x = mapx - 1) Or (PosY = Land.height - 1 And y = mapy - 1) Then
         Else
          .Index(i) = ((py * Land.TerrainV + y) * Land.MaxVertexX + px * Land.TerrainV + x)
          .Index(i + 1) = ((py * Land.TerrainV + y + 1) * Land.MaxVertexX + px * Land.TerrainV + x)
          .Index(i + 2) = ((py * Land.TerrainV + y + 1) * Land.MaxVertexX + px * Land.TerrainV + x + 1)
          .Index(i + 3) = ((py * Land.TerrainV + y) * Land.MaxVertexX + px * Land.TerrainV + x)
          .Index(i + 4) = ((py * Land.TerrainV + y + 1) * Land.MaxVertexX + px * Land.TerrainV + x + 1)
          .Index(i + 5) = ((py * Land.TerrainV + y) * Land.MaxVertexX + px * Land.TerrainV + x + 1)
          i = i + 6
         End If
        Next x
      Next y
    
    'load with low quality
      mapx = mapx / 2
      mapy = mapy / 2
      ReDim .Index2(mapx * mapy * 6)
      i = 0
      For y = 0 To mapy - 1
        For x = 0 To mapx - 1
         If (PosX = Land.width - 1 And x = mapx - 1) Or (PosY = Land.height - 1 And y = mapy - 1) Then
         Else
          .Index2(i) = ((py * Land.TerrainV + y * 2) * Land.MaxVertexX + px * Land.TerrainV + x * 2)
          .Index2(i + 1) = ((py * Land.TerrainV + y * 2 + 2) * Land.MaxVertexX + px * Land.TerrainV + x * 2)
          .Index2(i + 2) = ((py * Land.TerrainV + y * 2 + 2) * Land.MaxVertexX + px * Land.TerrainV + x * 2 + 2)
          .Index2(i + 3) = ((py * Land.TerrainV + y * 2) * Land.MaxVertexX + px * Land.TerrainV + x * 2)
          .Index2(i + 4) = ((py * Land.TerrainV + y * 2 + 2) * Land.MaxVertexX + px * Land.TerrainV + x * 2 + 2)
          .Index2(i + 5) = ((py * Land.TerrainV + y * 2) * Land.MaxVertexX + px * Land.TerrainV + x * 2 + 2)
          i = i + 6
         End If
        Next x
      Next y
    
    
    'load with low low quality
     mapx = mapx / 2
      mapy = mapy / 2
      ReDim .Index3(mapx * mapy * 6)
      i = 0
      For y = 0 To mapy - 1
        For x = 0 To mapx - 1
         If (PosX = Land.width - 1 And x = mapx - 1) Or (PosY = Land.height - 1 And y = mapy - 1) Then
         Else
          .Index3(i) = ((py * Land.TerrainV + y * 4) * Land.MaxVertexX + px * Land.TerrainV + x * 4)
          .Index3(i + 1) = ((py * Land.TerrainV + y * 4 + 4) * Land.MaxVertexX + px * Land.TerrainV + x * 4)
          .Index3(i + 2) = ((py * Land.TerrainV + y * 4 + 4) * Land.MaxVertexX + px * Land.TerrainV + x * 4 + 4)
          .Index3(i + 3) = ((py * Land.TerrainV + y * 4) * Land.MaxVertexX + px * Land.TerrainV + x * 4)
          .Index3(i + 4) = ((py * Land.TerrainV + y * 4 + 4) * Land.MaxVertexX + px * Land.TerrainV + x * 4 + 4)
          .Index3(i + 5) = ((py * Land.TerrainV + y * 4) * Land.MaxVertexX + px * Land.TerrainV + x * 4 + 4)
          i = i + 6
         End If
        Next x
      Next y
    End With
    

    
    Land.Terrain(numTerrain).Enabled = True
End Sub


Sub RenderLandscapeModule()

 Device.SetMaterial Material(Land.Material).Material
 Dim a As D3DMATRIX
 DirectX.IdentityMatrix a
 Device.SetTransform D3DTRANSFORMSTATE_WORLD, a
 For y = 0 To Land.height - 1
  For x = 0 To Land.width - 1
    NTerrain = y * Land.width + x + 1
    With Land.Terrain(NTerrain)
     If .Enabled = True Then
      If CheckIsVisible(.Sphere, .radius) = True Then
      If .texture > 0 Then Device.SetTexture 0, texture(.texture)
        dist = Abs(DirectX.VectorModulus(VSubtract(.Sphere, StartPos)))
        'three degradation levels
        If dist > Land.DegradationZ * 2 Then
          Device.DrawIndexedPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Land.Vertex(0), UBound(Land.Vertex()), .Index3(), UBound(.Index3), D3DDP_DEFAULT
        Else
          If dist > Land.DegradationZ Then
          Device.DrawIndexedPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Land.Vertex(0), UBound(Land.Vertex()), .Index2(), UBound(.Index2), D3DDP_DEFAULT
          Else
          Device.DrawIndexedPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Land.Vertex(0), UBound(Land.Vertex()), .Index(), UBound(.Index), D3DDP_DEFAULT
          End If
        End If
      End If
     End If
    End With
    
  Next x
 Next y
 
 'render rain or snow:
 If LandscapeRain = True Then
   'compute the new position:
   Dim Ve As D3DVECTOR
   'Ve = VNormalize(VSubtract(EndPos, StartPos))
   'Ve = VAdd(VScale(Ve, 5), StartPos)
   WhetherBS.MoveEmettor Vector(StartPos.x, StartPos.y + 8, StartPos.z)
   WhetherBS.RenderBillboardSystem
   WhetherBS.UpdateParticles TV_UPDATE_GENERATOR
 End If
 
  'render the water
  If Land.Water.Enabled = True Then
   Device.SetTransform D3DTRANSFORMSTATE_WORLD, a
  Device.SetRenderState D3DRENDERSTATE_LIGHTING, False
  If Land.Water.texture > 0 Then
   Device.SetTexture 0, texture(Land.Water.texture)
  Else
   Device.SetTexture 0, Nothing
  End If
  If Land.Water.Animated = True Then
   Land.Water.AnimKey = Land.Water.AnimKey + SystemFrame * 0.001
   aa = Land.Water.AnimKey: st = Land.Water.TextureScale
   'calculate Water "animation"
   Land.Water.Vertex(1).tu = st + Cos(aa) * st / 100
   Land.Water.Vertex(1).tv = st
   Land.Water.Vertex(2).tu = 0 + Cos(aa) * st / 100
   Land.Water.Vertex(2).tv = st
   Land.Water.Vertex(3).tu = st + Cos(aa) * st / 100
   Land.Water.Vertex(3).tv = 0
   Land.Water.Vertex(4).tu = 0 + Cos(aa) * st / 100
   Land.Water.Vertex(4).tv = 0
  If aa > 360 Then Land.Water.AnimKey = -360
  End If
  'alpha setting
  Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, Land.Water.Alphablended
  Device.SetRenderState D3DRENDERSTATE_SRCBLEND, Land.Water.SrcBlend
  Device.SetRenderState D3DRENDERSTATE_DESTBLEND, Land.Water.DestBlend
  
  'water rendering
  Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, Land.Water.Vertex(1), 4, D3DDP_DEFAULT
 End If
 
 
 If Land.DayFX.LandscapeSun = True Then
   Device.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, False
   Device.SetRenderState D3DRENDERSTATE_LIGHTING, True
   Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
   Device.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
   Device.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE
   Device.SetTexture 0, texture(Land.DayFX.SunTexture)
   Device.SetMaterial Material(Land.DayFX.SunMaterial).Material
   Dim b As D3DMATRIX
   MIdentity b
   b = MRotate(b, 0, -(GetCameraAngle - 90), 0)
   b = MTranslate(b, Land.DayFX.SunPosition.x + StartPos.x, Land.DayFX.SunPosition.y + StartPos.y, Land.DayFX.SunPosition.z + StartPos.z)
   Device.SetTransform D3DTRANSFORMSTATE_WORLD, b
   Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, Land.DayFX.SunVertex(1), 4, D3DDP_DEFAULT
   Device.SetTransform D3DTRANSFORMSTATE_WORLD, a
 End If
 
 'Render cloud layers :
 If Land.DayFX.LandscapeCloud = True Then
    Device.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, False
   Device.SetTransform D3DTRANSFORMSTATE_WORLD, a
   Device.SetRenderState D3DRENDERSTATE_LIGHTING, True
   Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
   Device.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCCOLOR
   Device.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA
   For i = 1 To UBound(Land.DayFX.Layers)
      Device.SetTexture 0, texture(Land.DayFX.Layers(i).texture)
      Device.SetMaterial Material(Land.DayFX.Layers(i).Material).Material
      Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_VERTEX, Land.DayFX.Layers(i).CVertex(1), 4, D3DDP_DEFAULT
   Next i
 End If
    Device.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, True
End Sub

Private Function CheckIsVisible(Center As D3DVECTOR, radius As Single) As Boolean
  CheckIsVisible = False
  clipstatus = Device.ComputeSphereVisibility(Center, radius)
 If clipstatus And &HFFF000 Then
   'not visible
 Else
  If clipstatus And &HFFF Then
   'partially visible :
   CheckIsVisible = True
  Else
   CheckIsVisible = True
   'entirely visible :
 End If
 
 End If
End Function
