VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LightEngine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Function CreateMaterial() As Integer
    For i = 1 To 100
    If Material(i).Active = False Then Exit For
   Next i
   CreateMaterial = i
   Material(i).Active = True
End Function

Public Function CreatePointLight(Position As D3DVECTOR, radius As Single, r, g, b, a) As Integer
   For i = 1 To 100
    If Light(i).Active = False Then Exit For
   Next i
   CreatePointLight = i
   Index = i
   Light(i).Active = True
   With Light(i).Light
    .Ambient = DXColor(r, g, b, a)
    .Diffuse = DXColor(r, g, b, a)
    .range = radius
    .attenuation0 = 1
    .attenuation1 = 1
    .attenuation2 = 0
    .Position = Position
    .dltType = D3DLIGHT_POINT
   End With
   
   device.SetLight Index, Light(i).Light
   device.LightEnable Index, True
End Function
Public Function CreateDirectionalLight(Orientation As D3DVECTOR, r, g, b, a) As Integer
   For i = 1 To 100
    If Light(i).Active = False Then Exit For
   Next i
   CreateDirectionalLight = i
   Index = i
   With Light(i).Light
    .Ambient = DXColor(r, g, b, a)
    .Diffuse = DXColor(r, g, b, a)
    '.range = Radius
    .attenuation0 = 1
    .attenuation1 = 1
    .attenuation2 = 0
    .dltType = D3DLIGHT_DIRECTIONAL
    .Direction = Orientation
   End With
   device.SetLight Index, Light(i).Light
   device.LightEnable Index, True
End Function

Public Function DeleteLight(LightIndex As Integer)
  Light(LightIndex).Active = False
  EnableLight LightIndex, False
End Function


Function DeleteMaterial(MaterialIndex As Integer)
  Material(MaterialIndex).Active = False
  Material(MaterialIndex).Enabled = False
End Function

Public Sub EnableLight(LightIndex As Integer, Enabled As Boolean)
 device.LightEnable LightIndex, Enabled
End Sub


Sub SetLightAmbientColor(Index, r, g, b, a)
  Light(Index).Light.Ambient = DXColor(r, g, b, a)
 device.SetLight Index, Light(Index).Light
End Sub
Sub SetLightDiffuseColor(Index, r, g, b, a)
  Light(Index).Light.Diffuse = DXColor(r, g, b, a)
 device.SetLight Index, Light(Index).Light
End Sub
Sub SetLightDirection(Index, x, y, z)
 Light(Index).Light.Direction = Vector(x, y, z)
 device.SetLight Index, Light(Index).Light
End Sub

Sub SetLightSpecularColor(Index, r, g, b, a)
  Light(Index).Light.Specular = DXColor(r, g, b, a)
 device.SetLight Index, Light(Index).Light
End Sub
Sub SetLightPhiTheta(Index, phi, theta)
  Light(Index).Light.phi = phi
  Light(Index).Light.theta = theta
  device.SetLight Index, Light(Index).Light
End Sub
Sub SetLightFalloff(Index, Falloff)
  Light(Index).Light.Falloff = Falloff
 device.SetLight Index, Light(Index).Light
 
End Sub
Sub SetLightColor(Index, r, g, b, a)
  Light(Index).Light.Ambient = DXColor(r, g, b, a)
    Light(Index).Light.Diffuse = DXColor(r, g, b, a)
 device.SetLight Index, Light(Index).Light
End Sub
Sub SetLightAttenuation(Index, a1, a2, a3)
   Light(Index).Light.attenuation0 = a1
   Light(Index).Light.attenuation1 = a2
   Light(Index).Light.attenuation2 = a3
End Sub
Sub SetLightPosition(LightIndex As Integer, Position As D3DVECTOR)
  Light(LightIndex).Light.Position = Position
  device.SetLight LightIndex, Light(LightIndex).Light
End Sub

Sub SetLightRadius(Index, radius)
  Light(Index).Light.range = radius
  device.SetLight Index, Light(Index).Light
End Sub
Function SetMaterialAmbient(Index, r, g, b, a)
  Material(Index).Material.Ambient = DXColor(r, g, b, a)
End Function
Function SetMaterialDiffuse(Index, r, g, b, a)
  Material(Index).Material.Diffuse = DXColor(r, g, b, a)
End Function
Function SetMaterialEmissive(Index, r, g, b, a)
  Material(Index).Material.emissive = DXColor(r, g, b, a)
End Function
Function SetMaterialSpecular(Index, r, g, b, a)
  Material(Index).Material.Specular = DXColor(r, g, b, a)
End Function
Function SetMaterialPower(Index, power)
  Material(Index).Material.power = power
End Function

