VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Mesh"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'  TrueVision Engine 0.88
'-------------------------
'  Mesh class
'
' 28/06/00 : 4-Direction billboard added
'
' 23/06/00 : Milkshape 3D Ascii file support (texture)
'            Beginning of 3D skeletal Animation




Private Motion As New Motion
Private MeshIndex As Integer
Private Matrix As D3DMATRIX
 Private Enum colorBlocks
    Ambient
    Diffuse
    Specular
End Enum
Private Prim As Primitive
Public Enum Primitive
  TV_TRIANGLESTRIP = 5
  TV_TRIANGLELIST = 4
End Enum

Private MaterialIndex  As Integer
Private TypeVertex As Integer
Private Billboard As Boolean
Private AlphaBlending As Boolean
Private BlendSrc, BlendDest
Private Position As D3DVECTOR
Private Rotation As D3DVECTOR
Private XFile As Boolean
Private TextureI As Integer
Private FileX As XFileClass
Private SphereComputed
Private T4D(4) As Integer, T4DEnabled As Boolean
  Dim LV() As D3DLVERTEX
  Dim FaceIndex() As Integer

Private Type tdsHeader
    Header As Integer
    Length As Long
End Type

Public Visible As Integer
Private Type aFace
    a As Integer
    b As Integer
    c As Integer
    Flags As Integer
End Type

Private Type UVmap
    U As Single
    v As Single
End Type

Private Type udColorByte
    Red As Byte
    Green As Byte
    Blue As Byte
End Type

Private Type aMaterial
    MatName As String
    Ambient As D3DCOLORVALUE
    Diffuse As D3DCOLORVALUE
    Specular As D3DCOLORVALUE
    MapName As String       ' Diffuse Map
    MapPercent As Integer   ' Percentage map is used
End Type
Public Enum MeshFlags
 TV_BILLBOARD_MESH = 1
 TV_ALPHABLENDING = 2
 TV_GLOWMESH = 4
 TV_TRANSFORMED_INFO = 8
 TV_XFILE_MESH = 16
End Enum
'
' TVO file :
' for C++ (later)
Private Type TVOHeader
  magic As String * 4
  MeshVersion As Single
  TVOffset As Long
End Type
Private Type TVODirectory
  VertexesOffset As Long
  VertexesCount As Long
  AnimationOffset As Long
  AnimationLength As Long
  FaceIndexesOffset As Long
  FaceIndexesLength As Long
End Type
  


Function GetCurrentAnimationKey() As Single
  GetCurrentAnimationKey = Mesh(MeshIndex).Anim.CurrentKey
End Function


' Just for MilkShape file parsing
'
Private Function GetLong(lin, res)
   t = InStr(lin, " ")
   GetLong = Val(Left(lin, t))
   res = Mid(lin, t + 1)
End Function
Sub AddBox(MinX, MinY, MinZ, MaxX, MaxY, maxZ)
   Dim min As D3DVECTOR, max As D3DVECTOR
   Dim c(8) As D3DVECTOR
    min = Vector(MinX, MinY, MinZ)
    max = Vector(MaxX, MaxY, maxZ)
    c(1).x = min.x
    c(2).x = min.x
    c(3).x = min.x
    c(4).x = min.x
    c(5).x = max.x
    c(6).x = max.x
    c(7).x = max.x
    c(8).x = max.x
    
    c(1).y = min.y
    c(2).y = min.y
    c(3).y = max.y
    c(4).y = max.y
    c(5).y = min.y
    c(6).y = min.y
    c(7).y = max.y
    c(8).y = max.y
        
    c(1).z = min.z
    c(2).z = max.z
    c(3).z = min.z
    c(4).z = max.z
    c(5).z = min.z
    c(6).z = max.z
    c(7).z = min.z
    c(8).z = max.z
    
'--------
   AddVector c(1), 0, 1, 0, 0, -1
   AddVector c(3), 0, 0, 0, 0, -1
   AddVector c(7), 1, 0, 0, 0, -1

   AddVector c(1), 0, 1, 0, 0, -1
   AddVector c(7), 1, 0, 0, 0, -1
   AddVector c(5), 1, 1, 0, 0, -1
   
'----------
   AddVector c(5), 0, 1, 1, 0, 0
   AddVector c(7), 0, 0, 1, 0, 0
   AddVector c(8), 1, 0, 1, 0, 0

   AddVector c(5), 0, 1, 1, 0, 0
   AddVector c(8), 1, 0, 1, 0, 0
   AddVector c(6), 1, 1, 1, 0, 0
'----------
   AddVector c(2), 0, 1, -1, 0, 0
   AddVector c(4), 0, 0, -1, 0, 0
   AddVector c(3), 1, 0, -1, 0, 0

   AddVector c(2), 0, 1, -1, 0, 0
   AddVector c(3), 1, 0, -1, 0, 0
   AddVector c(1), 1, 1, -1, 0, 0
'----------
   AddVector c(6), 0, 1, 0, 0, 1
   AddVector c(8), 0, 0, 0, 0, 1
   AddVector c(4), 1, 0, 0, 0, 1

   AddVector c(6), 0, 1, 0, 0, 1
   AddVector c(4), 1, 0, 0, 0, 1
   AddVector c(2), 1, 1, 0, 0, 1

'----------------
   AddVector c(3), 0, 1, 0, 1, 0
   AddVector c(4), 0, 0, 0, 1, 0
   AddVector c(8), 1, 0, 0, 1, 0

   AddVector c(3), 0, 1, 0, 1, 0
   AddVector c(8), 1, 0, 0, 1, 0
   AddVector c(7), 1, 1, 0, 1, 0
'------------------
   AddVector c(6), 0, 1, 0, -1, 0
   AddVector c(5), 0, 0, 0, -1, 0
   AddVector c(1), 1, 0, 0, -1, 0

   AddVector c(6), 0, 1, 0, -1, 0
   AddVector c(1), 1, 0, 0, -1, 0
   AddVector c(2), 1, 1, 0, -1, 0
'---------------------

 SetPrimitiveType TV_TRIANGLELIST
 SetVertexType TV_VERTEX
 SetMeshType 0
End Sub


Private Sub AddVector(v As D3DVECTOR, tu, tv, nx, ny, nz)
  AddVertex v.x, v.y, v.z, DirectX.CreateColorRGBA(1, 1, 1, 1), CSng(tu), CSng(tv), nx, ny, nz
End Sub

Function GetMotionObject() As Motion
  Set GetMotionObject = Motion
End Function

Sub MoveForward(StepPerSecond As Single, Optional FollowLandscape As Boolean, Optional AltitudeOverLandscape As Single = 5)
 Step = StepPerSecond * SystemFrame / 1000
 SetPosition GetPosition.x + Cos(Rotation.y * PIFactor) * Step, GetPosition.y, Cos(Rotation.y * PIFactor) * Step + GetPosition.z
 If FollowLandscape = True Then
   Position.y = GetHeightModule(Position.x, Position.z) + AltitudeOverLandscape
 End If
End Sub

Sub RotateMesh(x As Single, y As Single, z As Single)
  Rotation = VAdd(Rotation, Vector(x, y, z))
End Sub

Sub SaveMeshToFile(filename As String)
  'can't copy in Pak files
  Open filename For Binary As 45
   Put #45, , "TVOM"
   Put #45, , Prim
   Put #45, , TypeVertex
   Put #45, , TextureI
   Put #45, , BlendDest
   Put #45, , BlendSrc
   Put #45, , AlphaBlending
   Put #45, , Billboard
   Put #45, , Position
   Put #45, , Rotation
   Put #45, , Mesh(MeshIndex)
  Close #45
End Sub
Sub LoadTrueVisionMeshFile(filename As String)
  TestPAKFile filename
  Open filename For Binary As 45
   'check if the file is a TrueVision mesh file with "Magic" string
   Dim magic As String * 4
   Get #45, , magic
   If magic <> "TVOM" Then
     AddLog filename + " isn't a good TrueVision mesh file "
     Exit Sub
   End If
   Get #45, , Prim
   Get #45, , TypeVertex
   Get #45, , TextureI
   Get #45, , BlendDest
   Get #45, , BlendSrc
   Get #45, , AlphaBlending
   Get #45, , Billboard
   Get #45, , Position
   Get #45, , Rotation
   Get #45, , Mesh(MeshIndex)
  Close #45
  DeletePAKTemp filename
End Sub

Sub SetAnimationSpeed(Speed As Single)

End Sub

Private Function CheckIfVisible() As Boolean
  CheckIfVisible = False
  clipstatus = Device.ComputeSphereVisibility(Mesh(MeshIndex).Center, Mesh(MeshIndex).radius)
 If clipstatus And &HFFF000 Then
   'not visible
   Visible = 0
 Else
  If clipstatus And &HFFF Then
   'partially visible :
   CheckIfVisible = True
   Visible = 1
  Else
   CheckIfVisible = True
   'entirely visible
   Visible = 2
 End If
 
 End If
End Function

Public Sub ComputeSphere()
  'compute first the bounding box of the mesh
   Dim min As D3DVECTOR
   Dim max As D3DVECTOR
   min = Vector(99999999, 999999999, 999999999)
   max = Vector(-999999999, -999999999, -999999999)
   
   For i = 1 To UBound(Mesh(MeshIndex).LVertex)
     With Mesh(MeshIndex).LVertex(i)
       If .x > max.x Then max.x = .x
       If .y > max.y Then max.y = .y
       If .z > max.z Then max.z = .z
       If .x < min.x Then min.x = .x
       If .y < min.y Then min.y = .y
       If .z < min.z Then min.z = .z
     End With
   Next i
   
   Mesh(MeshIndex).BBoxMin = min
   Mesh(MeshIndex).BBoxMax = max
   
   'find the center of the sphere
   Mesh(MeshIndex).Center = Vector((min.x + max.x) / 2, (min.y + max.y) / 2, (min.z + max.z) / 2)
   
   
   Dim Rad As D3DVECTOR
   Rad.x = Abs((max.x - min.x) / 2)
   Rad.y = Abs((max.y - min.y) / 2)
   Rad.z = Abs((max.z - min.z) / 2)
 
 'take the biggest radius
 If Rad.x >= Rad.y And Rad.x >= Rad.z Then
   Mesh(MeshIndex).radius = Rad.x * Sqr(2)
 End If
 If Rad.y >= Rad.x And Rad.y >= Rad.z Then
   Mesh(MeshIndex).radius = Rad.y * Sqr(2)
 End If
 If Rad.z >= Rad.x And Rad.z >= Rad.y Then
   Mesh(MeshIndex).radius = Rad.z * Sqr(2)
 End If
 
 SphereComputed = True
 
End Sub

Function DetectCollision(Origin As D3DVECTOR, dest As D3DVECTOR)
   Dim t As Double, U As Double, v As Double, t1 As Double, u1 As Double, v1 As Double
   With Mesh(MeshIndex)
    'get the ray direction
    dest = VSubtract(dest, Origin)
    DirectX.VectorNormalize dest
       
 'if there are triangle lists
 If Prim = TV_TRIANGLELIST Then
   For x = 1 To UBound(.LVertex) - 2 Step 3
     g = Ray_Tri(Origin, dest, vert(.LVertex(x)), vert(.LVertex(x + 1)), vert(.LVertex(x + 2)), t, U, v)
     If (g = 1 And t < PrecisionCollide And t >= 0) Then
          DetectCollision = True
          Exit Function
     End If
   Next x
 Else
 'if there are triangle strips
   For x = 1 To UBound(.LVertex) - 2
     g = Ray_Tri(Origin, dest, vert(.LVertex(x)), vert(.LVertex(x + 1)), vert(.LVertex(x + 2)), t, U, v)
     If (g = 1 And t < PrecisionCollide And t >= 0) Then
          DetectCollision = True
          Exit Function
     End If
   Next x
 
 End If
  End With
  
End Function
Public Sub ClearMesh()
  ReDim Mesh(MeshIndex).Vertex(0)
  ReDim Mesh(MeshIndex).LVertex(0)
  ReDim Mesh(MeshIndex).GroupIndex(0)
  ReDim Mesh(MeshIndex).TLVertex(0)
End Sub
Friend Function GetMeshIndex() As Integer
 GetMeshIndex = MeshIndex
End Function

Function GetPosition() As D3DVECTOR
   GetPosition = Position
End Function
Function GetRotation() As D3DVECTOR
  GetRotation = Rotation
End Function

Function GetSphereVisibilityStatus() As Long
 'get the clip status between sphere and frustum view clip planes
 GetSphereVisibilityStatus = Device.ComputeSphereVisibility(Mesh(MeshIndex).Center, Mesh(MeshIndex).radius)
End Function

Function GetVertexCount() As Long
  GetVertexCount = UBound(Mesh(MeshIndex).Vertex)
End Function

Sub Load3DsMesh(filename As String)



    SetPrimitiveType TV_TRIANGLELIST
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "3DS: Load3ds"
   ' AddLog "Load 3ds :" + filename
    Dim VbCounter As Long
    Dim ColorByte As udColorByte
    Dim PercentInt As Integer
    Dim cBlock As Byte              ' Type of color currently being imported. See colorblock Enum
    Dim Materials() As aMaterial
    Dim mCount As Integer           ' Number of loaded materials
    
    Dim Info As tdsHeader           ' Header of Chunk
    Dim Index As Long               ' Index in File -- filepos
        
    Dim MeshName As String          ' Current Mesh Name
    Dim Done As Boolean
    
    Dim vcount As Long              ' redundant vertex counter
    Dim vertices As Integer         ' ""
    Dim faces As Integer            ' Numbder of faces
    Dim VertexList() As D3DVECTOR   ' #DS file Vertexlist
    Dim Facelist() As aFace         ' Facelist
    Dim vbuf() As Long              ' redunant vertexlist for vertex buffer
    'Dim MeshVertices() As D3DVERTEX ' Actual constructor for vertex buffer
    
    Dim UVCoords() As UVmap         ' #DS file UV coordinates
    Dim UVbuf() As UVmap            ' Buffer for MeshVertices construction
    Dim nBuf() As D3DVECTOR         ' Buffer for the temp face Normals
    Dim Normals() As D3DVECTOR      ' Array to hold temporary face normals
    
    Dim tVector As D3DVECTOR
    Dim char As Byte
    Dim Strz As String              ' All Generic definitions for reading
    Dim Dword As Long               ' types stored in #DS file via C typedefs
    Dim word As Integer
    Dim Real As Single
    Dim i As Long
        thescale = 1
    Dim UVCoordsTrue As Boolean
    UVCoordsTrue = False
        
    Dim MinX, MinY, MinZ As Single
    Dim MaxX, MaxY, maxZ As Single
    
    Index = 1

    TestPAKFile filename
    Open filename For Binary As #1
    
 
    While Not EOF(1)
        Get #1, Index, Info
        Index = Index + 6
        
        Select Case Info.Header
            Case &H4D4D:    ' OGRE Chunk
                ErrString = "OGRE Chunk"
                
            Case &H2:       ' 3DS Version Number
                ErrString = "3DS Version"
                Get #1, Index, Dword
                Index = Index + Len(Dword)
                
            Case &H3D3D:    ' 3D Editor Header
                ErrString = "3D Editor Chunk"
                
            Case &H3D3E:    ' Mesh Version
                ErrString = "Mesh Version"
                Get #1, Index, Dword
                Index = Index + Len(Dword)
                
            Case &H4000:    ' Object Block -- Includes Name
                ErrString = "Object Block"
                Done = False
                MeshName = ""
                While Not Done
                    Get #1, Index, char
                    If char <> 0 Then
                        MeshName = MeshName + Chr(char)
                    Else
                        Done = True
                    End If
                    Index = Index + Len(char)
                Wend
                
            Case &H4100:    ' Triangular Mesh
                ErrString = "Triangular Mesh"
                
            Case &H4110:    ' Verticies List
                ErrString = "Vertices"
                Get #1, Index, vertices
                Index = Index + Len(vertices)
                ReDim VertexList(vertices)
                Get #1, Index, VertexList
                Index = Index + Len(VertexList(0)) * CLng(vertices)
                
                MinX = 500000:  MinY = MinX: MinZ = MinY
                MaxX = -500000: MaxY = MaxX: maxZ = MaxY
                  
                For i = 0 To vertices - 1
                    With VertexList(i)
                        VertexList(i).x = VertexList(i).x * thescale
                        VertexList(i).y = VertexList(i).y * thescale
                        VertexList(i).z = VertexList(i).z * thescale
                        If .x < MinX Then MinX = .x
                        If .y < MinY Then MinY = .y
                        If .z < MinZ Then MinZ = .z
                    
                        If .x > MaxX Then MaxX = .x
                        If .y > MaxY Then MaxY = .y
                        If .z > maxZ Then maxZ = .z
                    End With
                Next i
                
            Case &H4120:    ' Face List
                ErrString = "Face List"
                Get #1, Index, faces
                Index = Index + Len(faces)
                
                ReDim Facelist(faces)
                Get #1, Index, Facelist
                Index = Index + Len(Facelist(0)) * faces
                
                vcount = -1
                ReDim vbuf(faces * 3)
                ReDim UVbuf(faces * 3)
                For i = 0 To faces - 1
                    vcount = vcount + 3
                    'debug.print vcount
                    
                    If UVCoordsTrue Then
                        UVbuf(vcount - 2) = UVCoords(Facelist(i).a)
                        UVbuf(vcount - 1) = UVCoords(Facelist(i).b)
                        UVbuf(vcount) = UVCoords(Facelist(i).c)
                    End If
                    vbuf(vcount - 2) = Facelist(i).a
                    vbuf(vcount - 1) = Facelist(i).b
                    vbuf(vcount) = Facelist(i).c
                    
                    ' Make Face Normal
                    Dim a As D3DVECTOR, b As D3DVECTOR, c As D3DVECTOR
                    ReDim Preserve nBuf(vcount)
                    With DirectX
                        ' Face Normal
                        .VectorSubtract a, VertexList(vbuf(vcount - 2)), VertexList(vbuf(vcount - 1))
                        .VectorSubtract b, VertexList(vbuf(vcount - 2)), VertexList(vbuf(vcount))
                        .VectorCrossProduct c, a, b
                        .VectorNormalize c
                        
                        nBuf(vcount) = c
                        nBuf(vcount - 1) = c
                        nBuf(vcount - 2) = c
                        
                        'ReDim Preserve Normals(I)
                        'DX.DX7.VectorAdd Normals(I), nBuf(vcount), nBuf(vcount - 1)
                        'DX.DX7.VectorAdd Normals(I), Normals(I), nBuf(vcount - 2)
                        'With Normals(I)
                        '    .X = .X / 3
                        '    .Y = .Y / 3
                        '    .z = .z / 3
                        'End With
                        'DX.DX7.VectorNormalize Normals(I)
                    End With
                Next i
                UVCoordsTrue = False
                
                'Dim Summer As D3DVECTOR, scount As Integer, J As Long
                'ReDim Preserve Normals(vcount - 1)
                'For J = 0 To vcount - 1
                '    scount = 0
                '    Summer.X = 0
                '    Summer.Y = 0
                '    Summer.z = 0
                '    For I = 1 To vcount
                '        ' check if this vertex is used in another other face
                '        If I <> J And vbuf(I) = vbuf(J) Then
                '            DX.DX7.VectorAdd Summer, Summer, nBuf(I)
                '            DX.DX7.VectorAdd Summer, Summer, nBuf(J)
                '            scount = scount + 2
                '        End If
                '    Next I
                '    If scount > 0 Then
                '        Normals(J).X = Summer.X / scount
                '        Normals(J).Y = Summer.Y / scount
                '        Normals(J).z = Summer.z / scount
                '        DX.DX7.VectorNormalize Normals(J)
                '    End If
                'Next J
                
                ErrString = "Load3ds: Mesh Add"
               
                With Mesh(MeshIndex)
                     
                    For i = 0 To vcount - 1
                      'AddLog "Addvertex :" + CStr(vbuf(I))
                        AddVertex VertexList(vbuf(i)).x, VertexList(vbuf(i)).y, VertexList(vbuf(i)).z, DirectX.CreateColorRGBA(1, 1, 1, 1), UVbuf(i).U, UVbuf(i).v, nBuf(i).x, nBuf(i).y, nBuf(i).z
                    Next i
                End With
                
            Case &H4130:    ' Face Material List
                ErrString = "Face Material"
                Done = False
                Strz = ""
                While Not Done
                    Get #1, Index, char
                    If char <> 0 Then
                        Strz = Strz + Chr(char)
                    Else
                        Done = True
                    End If
                    Index = Index + Len(char)
                Wend
                
                Dim Q As Integer
                For Q = 1 To mCount
                    If Strz = Materials(Q).MatName Then
                        ' Store the Material Here
                        Exit For
                    End If
                Next Q
                
                Get #1, Index, word
                Index = Index + Len(word)
                For i = 1 To word
                    Get #1, Index, word
                    Index = Index + Len(word)
                Next i
                
            Case &H4140:    ' Face Texture Coordinate
                ErrString = "Face Texture Coordinates"
                Get #1, Index, word
                Index = Index + Len(word)
                ReDim UVCoords(word)
                Get #1, Index, UVCoords
                Index = Index + Len(UVCoords(0)) * CLng(word)
                UVCoordsTrue = True
            
            Case &H4160:
                ErrString = "Local Coordinate System"
                Get #1, Index, tVector
                Index = Index + Len(tVector)
                Get #1, Index, tVector
                Index = Index + Len(tVector)
                Get #1, Index, tVector
                Index = Index + Len(tVector)
                Get #1, Index, tVector
                'DD.MeshParent(ObjName2).Mesh(MeshName).position
                Index = Index + Len(tVector)
            
            Case &HA000:    ' Material Name
                ErrString = "Material Name"
                Done = False
                Strz = ""
                While Not Done
                    Get #1, Index, char
                    If char <> 0 Then
                        Strz = Strz + Chr(char)
                    Else
                        Done = True
                    End If
                    Index = Index + Len(char)
                Wend
                Materials(mCount).MatName = Strz
                
            Case &HAFFF:    ' Material Editor Chunk
                ErrString = "Material Editor Chunk"
                mCount = mCount + 1
                ReDim Preserve Materials(mCount)        ' Save stored materials
                
            Case &H10:      ' Single Color Chunk
                ErrString = "Single Color Chunk"
                Index = Index + Info.Length - 6
                
            Case &H11:      ' Byte Color Chunk
                ErrString = "Byte Color Chunk"
                Get #1, Index, ColorByte
                Index = Index + Len(ColorByte)
                
                Select Case cBlock
                    Case Ambient:
                        With Materials(mCount).Ambient
                            .a = 1
                            .r = ColorByte.Red / 255
                            .g = ColorByte.Green / 255
                            .b = ColorByte.Blue / 255
                        End With
                        
                    Case Diffuse:
                        With Materials(mCount).Diffuse
                            .a = 1
                            .r = ColorByte.Red / 255
                            .g = ColorByte.Green / 255
                            .b = ColorByte.Blue / 255
                        End With
                        
                    Case Specular:
                        With Materials(mCount).Specular
                            .a = 1
                            .r = ColorByte.Red / 255
                            .g = ColorByte.Green / 255
                            .b = ColorByte.Blue / 255
                        End With
                End Select
                
            Case &H30:      ' Percent Chunk Int format
                ErrString = "Percent Chunk INT"
                Get #1, Index, PercentInt
                Index = Index + Len(PercentInt)
                
            Case &H31:      ' Percent Chunk Float format
                ErrString = "Percent Chunk Float"
                Index = Index + Info.Length - 6
            
            Case &HA010:    ' Ambient color
                ErrString = "Ambient Color"
                cBlock = Ambient
                
            Case &HA020:    ' Diffuse Color
                ErrString = "Diffuse Color"
                cBlock = Diffuse
                
            Case &HA030:    ' Specular Color
                ErrString = "Specular Color"
                cBlock = Specular
                
            Case &HA200:    ' Map #1 -- diffuse?
                cBlock = Diffuse
                
            Case &HA300:    ' Map FileName
                ErrString = "Map File Name"
                Done = False
                Strz = ""
                While Not Done
                    Get #1, Index, char
                    If char <> 0 Then
                        Strz = Strz + Chr(char)
                    Else
                        Done = True
                    End If
                    Index = Index + Len(char)
                Wend
                Select Case cBlock
                    Case Diffuse:
                        Materials(mCount).MapName = Strz
                End Select
                
                'debug.print "Material Map Name: " & Strz
                
            Case &HA33A:    ' Map #2 -- Ambient?
                cBlock = Ambient
            
            Case &HA354
                ErrString = "V scaling for Map"
                Index = Index + Info.Length - 6
                
            Case &HA356
                ErrString = "U scaling for Map"
                Index = Index + Info.Length - 6
                
            Case &HA358
                ErrString = "U offset for Map"
                Index = Index + Info.Length - 6
                
            Case &HA35A
                ErrString = "V offset for Map"
                Index = Index + Info.Length - 6
                
            Case &HA35C
                ErrString = "Rotation Angle for Map"
                Index = Index + Info.Length - 6
                
            Case &H100:     ' One Unit
                ErrString = "One Unit"
                Get #1, Index, Real
                Index = Index + Len(Real)
                
            Case Else       ' Unknown Chunk
                ErrString = "Unknown Chunk"
                Index = Index + Info.Length - 6
        End Select
    Wend
    Close #1
    DeletePAKTemp filename
    Exit Sub
errs:
Close
AddLog "Error in 3Ds loader :" + CStr(Err.Number) + " " + Err.Description + " " + ErrString
End Sub

Sub LoadMilkshape3DAsciiFile(filename As String, WithAnimation As Boolean)
  ' Convert Milkshape3D ascii file in TrueVision mesh.
  
  
  TestPAKFile filename
  AddLog "Loading MS3D ascii file " + CStr(filename)

 On Error Resume Next
  Open filename For Input As 1
  Dim esse As String
  Do
   Input #1, esse
   If UCase(Left(esse, 8)) = "FRAMES: " Then
    NBFrame = Val(Mid(esse, 9))
   ' ReDim Preserve c.Animation(1)
          ReDim Mesh(MeshIndex).Anim.Animation(1)
     Mesh(MeshIndex).Anim.Animation(1).NBFrame = NBFrame
  End If
  If UCase(Left(esse, 8)) = "MESHES: " Then
    NBMesh = Val(Mid(esse, 9))
    AddLog "Mesh"
    
    '--------------------
    ' Get vertexes
    '-------------------
    'reset lvertexes
    ReDim Preserve LV(0)
    NV = 0
    
    For k = 1 To NBMesh
      
      Line Input #1, lin
      AddLog "lin " + lin
      Input #1, nbvertex
      AddLog "Mesh " + CStr(k) + " " + CStr(nbvertex) + " vertexes"
      VIndex = NV
      NV = NV + nbvertex
      ReDim Preserve LV(NV)
      ReDim Preserve Mesh(MeshIndex).Anim.VertexBones(NV)
     ' AddInfo "Mesh " + CStr(k) + ": " + CStr(NBVertex) + " vertex"
      For i = 1 To nbvertex
        Line Input #1, lin
        res = Mid(lin, InStr(lin, " ") + 1)
        t = InStr(res, " ")
        x = Val(Left(res, t))
        res = Mid(res, t + 1)
        
        t = InStr(res, " ")
        y = Val(Left(res, t))
        res = Mid(res, t + 1)
        
        t = InStr(res, " ")
        z = Val(Left(res, t))
        res = Mid(res, t + 1)
        
        t = InStr(res, " ")
        tu = Val(Left(res, t))
        res = Mid(res, t + 1)
        
        t = InStr(res, " ")
        tv = Val(Left(res, t))
        res = Mid(res, t + 1)
        
        t = InStr(res, " ")
        bone = Val(Left(res, 2))
        'res = Mid(res, t)
        LV(i + VIndex) = LVertex(x, y, z, DirectX.CreateColorRGBA(1, 1, 1, 1), tu, tv)
        Mesh(MeshIndex).Anim.VertexBones(i + VIndex) = bone
      Next i
      AddLog "normal"
      ' Face Normals (we'll see this later)
      Line Input #1, norm
      For i = 1 To norm
       Line Input #1, temp
      Next i
      
      ' Faces datas :
      f = 0
      Line Input #1, nbface
       AddLog "Face " + CStr(nbface)
    
      ReDim Preserve FaceIndex(nbface * 3)
      For i = 1 To nbface
      
        Line Input #1, lin
        res = Mid(lin, InStr(lin, " ") + 1)
        t = InStr(res, " ")
        t1 = Val(Left(res, t))
        res = Mid(res, t + 1)
        
        t = InStr(res, " ")
        t2 = Val(Left(res, t))
        res = Mid(res, t + 1)
        
        t = InStr(res, " ")
        t3 = Val(Left(res, t))
        res = Mid(res, t + 1)
        
        t = InStr(res, " ")
        tu = Val(res)
        'res = Mid(res, t + 1)
        
        FaceIndex(f) = t1 + VIndex  'in TrueVision, vertex are 1-based
        f = f + 1
        FaceIndex(f) = t2 + VIndex
        f = f + 1
        FaceIndex(f) = t3 + VIndex
        f = f + 1
     '   AddInfo "Face :" + CStr(t1) + " " + CStr(t2) + " " + CStr(t3)
      Next i
      AddLog "Set face array"
      SetFaceIndexArray k, FaceIndex()
    Next k
    
    End If
   
   'for materials and textures
   If UCase(Left(esse, 10)) = "MATERIALS:" Then
    NbMaterials = Val(Trim(Mid(esse, 11)))
    For i = 1 To NbMaterials
     Input #1, NomMaterial
     For h = 1 To 6
      Line Input #1, lin
     Next h
     Dim TextureFileName As String
     Input #1, TextureFileName
     If TextureFileName <> "" Then
     For Q = 1 To 100
       If TextureName(Q) = "" Then Exit For
     Next Q
     TXTIND = Q
     
     Set texture(TXTIND) = LoadSimpleTexture(TextureFileName, 0, 0)
     TextureName(TXTIND) = TextureFileName
     End If
    Next i
   End If
 
  ' for animation
   If UCase(Left(esse, 6)) = "BONES:" Then
     With Mesh(MeshIndex).Anim
     NbBones = Val(Trim(Mid(esse, 7)))
 '    AddInfo "Nombre de bones : " + CStr(NBBones)
     .NbBones = NbBones
     ReDim .Bones(NbBones)

      
      ReDim Preserve .Animation(1).frame(NBFrame)
      For i = 1 To NBFrame
       ReDim Preserve .Animation(1).frame(i).BonesPosition(NbBones)
       ReDim Preserve .Animation(1).frame(i).BonesRotation(NbBones)
      Next i
     
     For k = 1 To NbBones
      AddLog "Bone " + CStr(k)
      Input #1, Names
      Input #1, ParentName
       .Bones(k).Name = Names
      If ParentName = "" Then
       .Bones(k).Parent = 0
      Else
        For U = 1 To k
          If ParentName = .Bones(U).Name Then .Bones(k).Parent = U
        Next U
      End If
      AddLog "Pos"
       Line Input #1, lin
      With .Bones(k)
        temp = GetLong(lin, res)
       .Pos.x = GetLong(res, res)
       .Pos.y = GetLong(res, res)
       .Pos.z = GetLong(res, res)
       .Rot.x = GetLong(res, res)
       .Rot.y = GetLong(res, res)
       .Rot.z = GetLong(res, res)
      End With
      Line Input #1, Nbframe2
      AddLog "Anim"
      For z = 1 To Nbframe2
        Line Input #1, lin
        tz = Int(GetLong(lin, res))
       With .Animation(1).frame(tz)
        .BonesPosition(k).x = GetLong(lin, res)
        .BonesPosition(k).y = GetLong(res, res)
        .BonesPosition(k).z = GetLong(res, res)
       End With
      Next z
      Line Input #1, NBFrame3
      For z = 1 To NBFrame3
       Line Input #1, lin
        tz = Int(GetLong(lin, res))
       With .Animation(1).frame(tz)
        .BonesRotation(k).x = GetLong(lin, res)
        .BonesRotation(k).y = GetLong(res, res)
        .BonesRotation(k).z = GetLong(res, res)
       End With
      Next z
 
 
     Next k
   End With
  End If
   
 ' Text1.Text = Text1.Text + Chr(13) + Chr(10) + esse
 Loop Until EOF(1)
 
 'set vertexes array for the mesh (great new function !)
 AddLog "Add vertex array"
 
 'for non-animated mesh
 SetLVertexesArray LV
 'TV should support soon TV_VERTEX too (with materials)
 SetVertexType TV_LVERTEX

 If WithAnimation = True Then
 'for animated one :
 ReDim Preserve Mesh(MeshIndex).Anim.Animation(1).LV(UBound(Mesh(MeshIndex).LVertex))
 Mesh(MeshIndex).Anim.Animation(1).LV = Mesh(MeshIndex).LVertex
 
 
 
' Obtain relative vertexes
'
Dim PosBone() As D3DVECTOR, mat As D3DMATRIX
ReDim PosBone(NbBones)
With Mesh(MeshIndex).Anim
  For i = 1 To NbBones
     
      par = .Bones(i).Parent
      MIdentity mat
     mat = MRotate(mat, .Bones(i).Rot.x / PIFactor, .Bones(i).Rot.y / PIFactor, .Bones(i).Rot.z / PIFactor)
     mat = MTranslate(mat, .Bones(i).Pos.x, .Bones(i).Pos.y, .Bones(i).Pos.z)
     .Bones(i).Matrix = MMultiply(.Bones(par).Matrix, mat)
     PosBone(i) = MTransform(.Bones(i).Matrix, Vector(0, 0, 0))
  
  Next i
  
  For i = 1 To UBound(.VertexBones)
    par = .VertexBones(i)
    .Animation(1).LV(i) = LV(i)
    .Animation(1).LV(i).x = .Animation(1).LV(i).x - PosBone(par).x
    .Animation(1).LV(i).y = .Animation(1).LV(i).y - PosBone(par).y
    .Animation(1).LV(i).z = .Animation(1).LV(i).z - PosBone(par).z
     'AddLog CStr(.Animation(1).LV(i).x) + " " + CStr(.Animation(1).LV(i).y) + " " + CStr(.Animation(1).LV(i).z) + ""
  Next i
End With
End If
Close 1

End Sub
Sub LoadXMesh(filename As String)
  'I use the XClass from Microsoft SDK
  Set FileX = New XFileClass
   TestPAKFile filename
  FileX.Load DD, Device, filename
   DeletePAKTemp filename
   
  SetMeshType TV_XFILE_MESH
  
End Sub

Function AddVertex(x, y, z, Color, tu As Single, tv As Single, Optional nx, Optional ny, Optional nz, Optional UseTLVertex As Boolean) As Integer
  On Error Resume Next
  If UseTLVertex = True Then
    With Mesh(MeshIndex)
     ReDim Preserve .TLVertex(UBound(.TLVertex) + 1)
     .TLVertex(UBound(.TLVertex)) = TLVertex(x, y, z, Color, tu, tv)
     
  
   ' AddLog "TLVERTEX" + CStr(x) + " " + CStr(y) + " " + CStr(z) + " " + CStr(color) + " " + UBound(.TLVertex)
   End With
  Else
  'AddLog "LVERTEX3"
  With Mesh(MeshIndex)
     ReDim Preserve .LVertex(UBound(.LVertex) + 1)
     .LVertex(UBound(.LVertex)) = LVertex(x, y, z, Color, tu, tv)
       ReDim Preserve .Vertex(UBound(.Vertex) + 1)
     .Vertex(UBound(.Vertex)) = Vertex(x, y, z, 0, 0, 0, tu, tv)
   '  AddLog CStr(UBound(.LVertex)) + " " + CStr(x) + " " + CStr(y) + " " + CStr(z) + " " + CStr(tu) + " " + CStr(tv)
  End With
 End If
  
End Function
Public Sub RenderMesh()
  
  On Error GoTo pers
   
   'set identity matrix
   ResetMatrix
   

   If Billboard = False Then
     RotateM Rotation.x, Rotation.y, Rotation.z
   Else
     'orient the face in order of the camera angle
     RotateM 0, -(GetCameraAngle - 90), 0
   End If
   
   'move the mesh trought the scene
   Translate Position.x, Position.y, Position.z
   
   
   Device.SetTransform D3DTRANSFORMSTATE_WORLD, Matrix
   
  'if the sphere has been computed, then check if the sphere is in the frustum view
  If CheckIfVisible = False And SphereComputed = True Then Exit Sub
   
   'if there is a texture, apply it
   ERrStr = "texture pass"
   
   If AlphaBlending = True Then
    'if alphablending is on, enable it and set the dest and src parameters
    Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
    If BlendDest = 0 Then BlendDest = D3DBLEND_ONE
    If BlendSrc = 0 Then BlendSrc = D3DBLEND_ONE
    Device.SetRenderState D3DRENDERSTATE_DESTBLEND, BlendDest
    Device.SetRenderState D3DRENDERSTATE_SRCBLEND, BlendSrc
   Else
    'else disable alpha blending
    Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
    
   End If
   
   If TypeVertex = 2 Then
     'if they are VERTEX, then set light to on
     Device.SetRenderState D3DRENDERSTATE_LIGHTING, True
     Device.SetMaterial Material(MaterialIndex).Material
   Else
     Device.SetRenderState D3DRENDERSTATE_LIGHTING, False
   End If
   
   If XFile = False Then
    If Mesh(MeshIndex).GroupIndexCount > 0 Then
      With Mesh(MeshIndex)
        For i = 1 To .GroupIndexCount
           If .GroupIndex(i).FaceIndexCount > 0 Then
             If .GroupIndex(i).texture > 0 Then
               Device.SetTexture 0, texture(.GroupIndex(i).texture)
             Else
               Device.SetTexture 0, Nothing
             End If
             Select Case TypeVertex
               Case 1: Device.DrawIndexedPrimitive Prim, D3DFVF_LVERTEX, .LVertex(1), UBound(.LVertex), .GroupIndex(i).FaceIndex(), .GroupIndex(i).FaceIndexCount, D3DDP_DEFAULT
               Case 2: Device.DrawIndexedPrimitive Prim, D3DFVF_VERTEX, .Vertex(1), UBound(.Vertex), .GroupIndex(i).FaceIndex(), .GroupIndex(i).FaceIndexCount, D3DDP_DEFAULT
             End Select
           End If
        Next i
      End With
    Else
      ' choose the texture and render triangles
      
     'NEW ! For 4-direction billboarding (like Doom sprites)
     If Billboard = True And T4DEnabled = True Then
      a = GetCameraAngle
      b = GetRotation.y
      angle = b - a
      If angle < 0 Then angle = angle + 360
      Select Case angle
       Case 0 To 45, 316 To 360
        Tex = T4D(3)
       Case 46 To 135
        Tex = T4D(2)
       Case 136 To 225
        Tex = T4D(1)
       Case 226 To 315
        Tex = T4D(4)
       End Select
      Device.SetTexture 0, texture(Tex)
     Else
      If TextureI <> 0 Then
         Device.SetTexture 0, texture(TextureI)
      Else
         Device.SetTexture 0, Nothing
      End If
     End If
      Select Case TypeVertex
        Case 1: Device.DrawPrimitive Prim, D3DFVF_LVERTEX, Mesh(MeshIndex).LVertex(1), UBound(Mesh(MeshIndex).LVertex), D3DDP_DEFAULT
        Case 2: Device.DrawPrimitive Prim, D3DFVF_VERTEX, Mesh(MeshIndex).Vertex(1), UBound(Mesh(MeshIndex).Vertex), D3DDP_DEFAULT
        Case 3: Device.DrawPrimitive Prim, D3DFVF_TLVERTEX, Mesh(MeshIndex).TLVertex(1), UBound(Mesh(MeshIndex).TLVertex), D3DDP_DEFAULT
      End Select
    End If
   Else
     'if it's a X-file, let XClass do the dirty work
     FileX.Render Device
   End If
Exit Sub

pers:
AddLog "Error in RenderMesh :" + Err.Description + " " + CStr(Err.Number) + " " + ERrStr
End Sub

Public Sub ResetMatrix()
 'set the mesh matrix to identity
 DirectX.IdentityMatrix Matrix
End Sub

Private Sub RotateM(x As Single, y As Single, z As Single)
 'rotate the matrix around x,y,z-axis (angle in degrees)
 Matrix = MRotate(Matrix, x, y, z)
End Sub

Public Sub ScaleMesh(x As Single, y As Single, z As Single)
 'scale the mesh by a single
 Matrix = MScale(Matrix, x, y, z)
End Sub

Sub Set2DPlayerInfo(texture As texture, tu, tv, tu1, tv1)
 'set the texturecoordinates for the player info ("2D" TLVertex rendered for displying info)
 
 SetTexture texture
 SetTextureCoordinates 1, tu, tv
 SetTextureCoordinates 2, tu1, tv
 SetTextureCoordinates 3, tu, tv1
 SetTextureCoordinates 4, tu1, tv1
End Sub

Sub SetAlphaBlending(alpha As Boolean, Optional SrcBlend As Long, Optional DestBlend As Long)
 'enable or disable alpha blending
 ' the mode by default is D3DBLEND_ONE
 ' so the equation : alpha blending = color src + color dest
 
 If IsMissing(scrblend) = True Then
   BlendSrc = D3DBLEND_ONE
 Else
   BlendSrc = SrcBlend
 End If
 If IsMissing(DestBlend) = True Then
   BlendDest = D3DBLEND_ONE
 Else
   BlendDest = DestBlend
 End If
 AlphaBlending = alpha
End Sub

Public Sub SetBillboard4Direction(FrontTexture As texture, BackTexture As texture, LeftTexture As texture, RightTexture As texture)
 T4DEnabled = True
 T4D(1) = FrontTexture.TextureIndex
 T4D(2) = RightTexture.TextureIndex
 T4D(3) = BackTexture.TextureIndex
 T4D(4) = LeftTexture.TextureIndex
End Sub
Sub SetColor(r, g, b, a)
 'set the vertexes color : for LVERTEX only (VERTEX color are given by materials)
 If TypeVertex = 1 Then
 With Mesh(MeshIndex)
 For i = 1 To UBound(.LVertex)
    .LVertex(i).Color = DirectX.CreateColorRGBA(r, g, b, a)
 Next i
 End With
 End If
 If TypeVertex = 3 Then
  With Mesh(MeshIndex)
  For i = 0 To UBound(.TLVertex)
     .TLVertex(i).Color = DirectX.CreateColorRGBA(r, g, b, a)
  Next i
 End With
 
 End If
End Sub

Sub SetFaceIndexArray(GroupNum, FaceIndexes() As Integer, Optional FacesTexture As texture)
 If GroupNum > Mesh(MeshIndex).GroupIndexCount Then
  ReDim Preserve Mesh(MeshIndex).GroupIndex(GroupNum)
  Mesh(MeshIndex).GroupIndexCount = GroupNum
 End If
  ReDim Preserve Mesh(MeshIndex).GroupIndex(GroupNum).FaceIndex(UBound(FaceIndexes))
  Mesh(MeshIndex).GroupIndex(GroupNum).FaceIndex = FaceIndexes
  Mesh(MeshIndex).GroupIndex(GroupNum).FaceIndexCount = UBound(FaceIndexes)
 ' If IsMissing(FacesTexture) = True Then
 '  Mesh(MeshIndex).GroupIndex(GroupNum).texture = Mesh(MeshIndex).TextureI
 ' Else
 '  Mesh(MeshIndex).GroupIndex(GroupNum).texture = FacesTexture.TextureIndex
 ' End If
  AddLog "Finish..."
End Sub

Sub SetMaterial(Material As Integer, Optional XGroup As Integer)
 'set the material for a mesh or for a X-group
 
 If XFile = True Then
   If IsMissing(XGroup) Then
    For i = 1 To FileX.GetGroupCount
      FileX.SetGroupMaterial CInt(i), Material
    Next i
  Else
    If XGroup <= FileX.GetGroupCount Then
     FileX.SetGroupMaterial XGroup, Material
    End If
  End If
    
 Else
  MaterialIndex = Material
  AddLog "Material for mesh " + CStr(MaterialIndex)
 End If
End Sub

Friend Sub SetMeshType(Flags As MeshFlags)
  'set the mesh type (inaccessible from the user engine : "Friend" sub)
   
  If Flags And TV_ALPHABLENDING Then
   AlphaBlending = True
  Else
   AlphaBlending = False
  End If
  If Flags And TV_BILLBOARD_MESH Then
    Billboard = True
  Else
   Billboard = False
  End If
  If Flags And TV_TRANSFORMED_INFO Then
   AlphaBlending = True
   SetVertexType 3
   SetPrimitiveType TV_TRIANGLESTRIP
  End If
  If Flags And TV_XFILE_MESH Then
   SetVertexType 2
   SetPrimitiveType TV_TRIANGLELIST
   XFile = True
  Else
   XFile = False
  End If
End Sub

 

Public Sub SetPosition(x, y, z)
  Position = Vector(x, y, z)
End Sub

Public Sub SetPrimitiveType(DPT As Primitive)
  Prim = DPT
End Sub

Public Sub SetRotation(x As Single, y As Single, z As Single)
  Rotation = Vector(x, y, z)
End Sub

Public Sub SetTexture(texture As texture, Optional Group As Integer = -1)
 If XFile = False Then
  If Group = -1 Then
    TextureI = texture.TextureIndex
  Else
   Mesh(MeshIndex).GroupIndex(Group).texture = texture.TextureIndex
  End If
 Else
  If IsMissing(Group) Then
    For i = 1 To FileX.GetGroupCount
      FileX.SetGroupTexture CInt(i), texture.TextureIndex
    Next i
  Else
    If Group <= FileX.GetGroupCount Then
     FileX.SetGroupTexture Group, texture.TextureIndex
    End If
  End If
    
 End If
End Sub

Sub SetTextureCoordinates(Index, tu, tv)
 '  AddLog "Set Coord" + CStr(index) + " " + CStr(TypeVertex)
   If TypeVertex = 3 Then
    Mesh(MeshIndex).TLVertex(Index).tu = tu
    Mesh(MeshIndex).TLVertex(Index).tv = tv
   Else
    Mesh(MeshIndex).LVertex(Index).tu = tu
    Mesh(MeshIndex).LVertex(Index).tv = tv
    Mesh(MeshIndex).Vertex(Index).tu = tu
    Mesh(MeshIndex).Vertex(Index).tv = tv
   
   End If
End Sub

Sub SetVertexesArray(Vertexes() As D3DVERTEX)
 VC = UBound(Vertexes)
 ReDim Mesh(MeshIndex).Vertex(VC)
 Mesh(MeshIndex).Vertex = Vertexes()
End Sub

Sub SetLVertexesArray(LVertexes() As D3DLVERTEX)
 VC = UBound(LVertexes)
 ReDim Mesh(MeshIndex).LVertex(VC)
 Mesh(MeshIndex).LVertex = LVertexes()
End Sub
Public Sub SetVertexType(VType As Integer)
 TypeVertex = VType
End Sub
Public Sub Translate(x, y, z)
 Matrix = MTranslate(Matrix, x, y, z)
End Sub
Sub UpdateAnimation()
 On Error GoTo errgest
   Dim v1 As D3DVECTOR, v2 As D3DVECTOR, vt1 As D3DVECTOR, vt2 As D3DVECTOR, vt3 As D3DVECTOR, vt4 As D3DVECTOR, vt5 As D3DVECTOR
 Dim vt7 As D3DVECTOR, VT As D3DVECTOR
 ERrStr = "Mesh bones reset"
  For i = 0 To Mesh(MeshIndex).Anim.NbBones
  Mesh(MeshIndex).Anim.Bones(i).NowPos = Vector(0, 0, 0)
  DirectX.IdentityMatrix Mesh(MeshIndex).Anim.Bones(i).Matrix
  Next i
 
  With Mesh(MeshIndex).Anim
  ''  .CurrentKey = .CurrentKey + KeyPlus
  'ERrStr = "ChangeKey"
  '
  '  For i = 1 To UBound(.Bones)
  '          ERrStr = "Get bones"
  '        par = .Bones(i).Parent
  '        vt3 = .Bones(par).NowRot
  '        vt7 = .Bones(par).NowPos
  '        vt4 = .Bones(i).Pos
  '        vt5 = .Bones(i).Rot
  '        'Debug.Print i, .CurrentKey
  '        If .CurrentKey >= .Animation(1).NBFrame Then
  '           h = Int(.CurrentKey)
  '           j = 1
  '        Else
  '           h = Int(.CurrentKey)
  '           j = Int(.CurrentKey) + 1
  '        End If
  '          ERrStr = "GetSub"
  '        vt2 = VSubtract(.Animation(1).frame(j).BonesRotation(i), .Animation(1).frame(h).BonesRotation(i))
  '        '.Print vt2.x, vt2.y, vt2.z
  '        laps = .CurrentKey - Int(.CurrentKey)
  '       ' Debug.Print laps
  '       ' Debug.Print i; "2"
   '         ERrStr = "FrameGet"
  '        leng = Sqr(vt4.x ^ 2 + vt4.y ^ 2 + vt4.z ^ 2)
  '
  '        DirectX.VectorRotate vt4, vt4, Vector(1, 0, 0), -(vt5.x + vt3.x + vt2.x * laps + .Animation(1).frame(h).BonesRotation(i).x)
  '        DirectX.VectorRotate vt4, vt4, Vector(0, 1, 0), -(vt5.y + vt3.y + vt2.y * laps + .Animation(1).frame(h).BonesRotation(i).y)
  '        DirectX.VectorRotate vt4, vt4, Vector(0, 0, 1), -(vt5.z + vt3.z + vt2.z * laps + .Animation(1).frame(h).BonesRotation(i).z)
  '
  '     '   .BonesPos(i) = Vector(vt5.x + vt4.x * leng, vt5.y + vt4.y * leng, vt5.z + vt4.z * leng)
  '     '   .BonesRot(i) = Vector(vt7.x + vt3.x + vt.x + laps * vt2.x, vt7.y + vt3.y + vt.y + laps * vt2.y, vt7.z + vt3.z + vt.z + laps * vt2.z)
  '   ' .BonesPos(i).x = .Perso.Animation(1).Bones(i).pos.x + .BonesPos(.Perso.Animation(1).Bones(i).Parent).x
  '   ' .BonesPos(i).y = .Perso.Animation(1).Bones(i).pos.y + .BonesPos(.Perso.Animation(1).Bones(i).Parent).y
  '   ' .BonesPos(i).z = .Perso.Animation(1).Bones(i).pos.z + .BonesPos(.Perso.Animation(1).Bones(i).Parent).z
  '       'Debug.Print i; " "; .BonesPos(i).x; " "; .BonesPos(i).y; " "; .BonesPos(i).z
  '       'Debug.Print .BonesRot(i).x; " "; .BonesRot(i).y; " "; .BonesRot(i).z
  '    'Debug.Print par, .BonesPos(par).x, .BonesPos(par).y, .BonesPos(par).z
  '      ERrStr = "Now pos and rot"
  '    .Bones(i).NowRot = Vector(-(vt5.x + vt3.x + vt2.x * laps + .Animation(1).frame(h).BonesRotation(i).x), -(vt5.y + vt3.y + vt2.y * laps + .Animation(1).frame(h).BonesRotation(i).y), -(vt5.x + vt3.z + vt2.z * laps + .Animation(1).frame(h).BonesRotation(i).z))
  '    .Bones(i).NowPos.x = .Bones(par).NowPos.x + vt4.x * leng '.Perso.Animation(1).Bones(i).pos.x
  '    .Bones(i).NowPos.y = .Bones(par).NowPos.y + vt4.y * leng '.Perso.Animation(1).Bones(i).pos.y
  '    .Bones(i).NowPos.z = .Bones(par).NowPos.z + vt4.z * leng '.Perso.Animation(1).Bones(i).pos.z
  '
  '    '.BonesPos(i) = .Perso.Animation(1).Bones(i).pos
  '
  '  Next i
  '
 '
 'End With
 ' ERrStr = "Assign vertex"
 'For U = 0 To UBound(.LVertex)
 '    b = .Anim.VertexBones(U)
 '    'Debug.Print u, b
 '    .LVertex(U) = LVertex(.Anim.Animation(1).LV(U).x + .Anim.Bones(b).NowPos.x, .Anim.Animation(1).LV(U).y + .Anim.Bones(b).NowPos.y, .Anim.Animation(1).LV(U).z + .Anim.Bones(b).NowPos.z, DirectX.CreateColorRGBA(1, 1, 1, 1), .LVertex(U).tu, .LVertex(U).tv)
 '    '.Perso.Display(U) = LVertex(Vector(.Perso.LVertex(U).x + .BonesPos(b).x, .Perso.LVertex(U).y + .BonesPos(b).y, .Perso.LVertex(U).z + .BonesPos(b).z), DirectX.CreateColorRGBA(1, 1, 1, 1), .Perso.LVertex(U).tu, .Perso.LVertex(U).tv)
 'Next U


 'Dim Sque(100) As D3DLVERTEX
 'For i = 1 To .NbBones
 '   Sque(i * 2) = LVertex(.Anim.Bones(i).NowPos.x, .Anim.Bones(i).NowPos.y, .Anim.Bones(i).NowPos.z, DirectX.CreateColorRGBA(1, 1, 1, 1), 1, 1)
 '   par = .Anim.Bones(i).Parent
 '   Sque(i * 2 + 1) = LVertex(.Anim.Bones(par).NowPos.x, .Anim.Bones(par).NowPos.y, .Anim.Bones(par).NowPos.z, DirectX.CreateColorRGBA(1, 1, 1, 1), 1, 1)
 'Next i
 'Device.DrawPrimitive D3DPT_LINELIST, D3DFVF_LVERTEX, Sque(2), .Anim.NbBones * 2, D3DDP_DEFAULT

 If .CurrentKey >= .Animation(1).NBFrame Then
     ret = True
     .CurrentKey = 1
    Else
     ret = False
     .CurrentKey = .CurrentKey + SystemFrame / 500
 End If
 Dim mat As D3DMATRIX
 
 For i = 1 To .NbBones
   par = .Bones(i).Parent
   If .CurrentKey >= .Animation(1).NBFrame Then
     h = Int(.CurrentKey)
     j = 1
   Else
     h = Int(.CurrentKey)
     j = Int(.CurrentKey) + 1
  End If
  vt2 = VSubtract(.Animation(1).frame(j).BonesRotation(i), .Animation(1).frame(h).BonesRotation(i))
  laps = .CurrentKey - Int(.CurrentKey)
  MIdentity mat
  mat = MRotate(mat, (.Bones(i).Rot.x + vt2.x * laps + .Animation(1).frame(h).BonesRotation(i).x) / PIFactor, (.Bones(i).Rot.y + vt2.y * laps + .Animation(1).frame(h).BonesRotation(i).y) / PIFactor, (.Bones(i).Rot.z + vt2.z * laps + .Animation(1).frame(h).BonesRotation(i).z) / PIFactor)
  mat = MTranslate(mat, .Bones(i).Pos.x, .Bones(i).Pos.y, .Bones(i).Pos.z)
  .Bones(i).Matrix = MMultiply(.Bones(par).Matrix, mat)
 Next i
End With
 With Mesh(MeshIndex)
 For i = 1 To UBound(.Anim.VertexBones)
   b = .Anim.VertexBones(i)
   With .Anim.Bones(b).Matrix
    Mesh(MeshIndex).LVertex(i).x = .rc11 * Mesh(MeshIndex).Anim.Animation(1).LV(i).x + .rc21 * Mesh(MeshIndex).Anim.Animation(1).LV(i).y + .rc31 * Mesh(MeshIndex).Anim.Animation(1).LV(i).z + .rc41 * 1
    Mesh(MeshIndex).LVertex(i).y = .rc12 * Mesh(MeshIndex).Anim.Animation(1).LV(i).x + .rc22 * Mesh(MeshIndex).Anim.Animation(1).LV(i).y + .rc32 * Mesh(MeshIndex).Anim.Animation(1).LV(i).z + .rc42 * 1
    Mesh(MeshIndex).LVertex(i).z = .rc13 * Mesh(MeshIndex).Anim.Animation(1).LV(i).x + .rc23 * Mesh(MeshIndex).Anim.Animation(1).LV(i).y + .rc33 * Mesh(MeshIndex).Anim.Animation(1).LV(i).z + .rc43 * 1
   End With
 Next i
End With
Exit Sub
errgest:
AddLog "Error " + CStr(Err.Description) + " " + CStr(Err.Number) + " " + ERrStr + " " + CStr(h) + " " + CStr(j) + " " + CStr(i)
Resume Next
End Sub
Private Sub Class_Initialize()
  For i = 1 To 1000
   If Mesh(i).Active = False Then Exit For
  Next i
  Mesh(i).Active = True
  ReDim Preserve Mesh(i).LVertex(0)
  
  ReDim Preserve Mesh(i).Vertex(0)
  ReDim Preserve Mesh(i).TLVertex(0)
  
  ReDim Preserve Mesh(i).GroupIndex(0)
  Mesh(i).GroupIndexCount = -1
  
  MeshIndex = i
  Motion.InitMesh MeshIndex
  Mesh(i).Anim.CurrentKey = 1
  'AddLog "Mesh " + CStr(MeshIndex) + " active"
  Prim = TV_TRIANGLELIST
  vertextype = TV_LVERTEX
End Sub


Private Sub Class_Terminate()
 ClearMesh
 Mesh(MeshIndex).Active = False
End Sub


