VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Scene3D"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"

Private BSPTree As BSPTree
Private SkyTexture(6) As DirectDrawSurface7
Private Sky As Single
Private SkyVertex(36) As D3DLVERTEX
Private SkyMatrix As D3DMATRIX
Private Camera As New Camera

Public Enum EnumRenderMode
 TV_SOLID = D3DFILL_SOLID
 TV_WIREFRAME = D3DFILL_WIREFRAME
 TV_POINT = D3DFILL_POINT
End Enum

'Private SkyIndex(36) As Long, SkyMatrix As D3DMATRIX
Function CreateBillboard(texture As texture, x, y, z, width, height, Optional alpha, Optional src, Optional dest, Optional Color As Long = 16777215) As Mesh
 Set CreateBillboard = New Mesh
 
 If IsMissing(alpha) Then alpha = False: src = 0: dest = 0
 w = width / 2
 h = height / 2

 CreateBillboard.AddVertex 0, -h, -w, Color, 0.999, 0.999
 CreateBillboard.AddVertex 0, -h, w, Color, 0, 0.999
 CreateBillboard.AddVertex 0, h, -w, Color, 0.999, 0
 CreateBillboard.AddVertex 0, h, w, Color, 0, 0
 CreateBillboard.SetVertexType 1
 CreateBillboard.SetPrimitiveType TV_TRIANGLESTRIP

 CreateBillboard.SetMeshType TV_BILLBOARD_MESH Or TV_ALPHABLENDING
 CreateBillboard.SetTexture texture
 CreateBillboard.SetPosition x, y, z
End Function

Public Function CreateMeshBuilder() As Mesh
  Set CreateMeshBuilder = New Mesh
End Function

Public Sub CreateObject()
End Sub

Function Create2DPlayerInfoZone(x, y, x1, Y1, Color, UseViewportRatio As Boolean) As Mesh
Set Create2DPlayerInfoZone = New Mesh
 rx = x * ViewPort.lWidth
 ry = y * ViewPort.lHeight
 If UseViewportRatio = True Then
 rx1 = x1 * ViewPort.lWidth
 ry1 = Y1 * ViewPort.lHeight
 Else
 rx1 = rx + (x1 - x)
 ry1 = ry + (Y1 - y)
 End If
  
 Create2DPlayerInfoZone.AddVertex rx, ry, 0, Color, 0, 0, , , , True
 Create2DPlayerInfoZone.AddVertex rx1, ry, 0, Color, 1, 0, , , , True
 Create2DPlayerInfoZone.AddVertex rx, ry1, 0, Color, 0, 1, , , , True
 Create2DPlayerInfoZone.AddVertex rx1, ry1, 0, Color, 1, 1, , , , True
 Create2DPlayerInfoZone.SetMeshType TV_TRANSFORMED_INFO Or TV_ALPHABLENDING
 
 
End Function





Function GetCameraObject() As Camera
  Set GetCameraObject = Camera
End Function

Function GetDegreesCameraRotationY() As Single
   GetDegreesCameraRotationY = GetCameraAngle
End Function

Function GetSceneMesh() As Mesh
 Set GetSceneMesh = SceneMesh
End Function

Function LoadBSPTree(filename As String) As BSPTree
 Set BSPTree = New BSPTree
 BSPTree.Load filename
 Set LoadBSPTree = BSPTree
End Function

Sub LoadQuakeHalfLifeMap(filename As String)
  LoadMapFile filename
End Sub

Public Sub LoadScene(TrueVisionFile As String)
End Sub

' We need 6 sky textures (sky1.bmp, sky2.bmp ...) but write the first file (sky1.bmp)
'
Sub LoadSky(TextureFileName As String, Optional SkyDistance As Single = 1000)
  ext = Right(TextureFileName, 4)
  file = Left(TextureFileName, Len(TextureFileName) - 5)
  
  For i = 1 To 6
    Set SkyTexture(i) = LoadSimpleTexture(file + CStr(i) + ext, 0, 0)
  Next i
  Sky = SkyDistance
  c = DirectX.CreateColorRGBA(1, 1, 1, 1)
  
  'left
  SkyVertex(1) = LVertex(-Sky, -Sky, -Sky, c, 1, 1)
  SkyVertex(2) = LVertex(Sky, -Sky, -Sky, c, 0, 1)
  SkyVertex(3) = LVertex(-Sky, Sky, -Sky, c, 1, 0)
  SkyVertex(4) = LVertex(Sky, Sky, -Sky, c, 0, 0)

  'right
  SkyVertex(6) = LVertex(-Sky, -Sky, Sky, c, 1, 1)
  SkyVertex(5) = LVertex(Sky, -Sky, Sky, c, 0, 1)
  SkyVertex(8) = LVertex(-Sky, Sky, Sky, c, 1, 0)
  SkyVertex(7) = LVertex(Sky, Sky, Sky, c, 0, 0)

  'front
  SkyVertex(9) = LVertex(-Sky, -Sky, -Sky, c, 1, 1)
  SkyVertex(10) = LVertex(-Sky, Sky, -Sky, c, 1, 0)
  SkyVertex(11) = LVertex(-Sky, -Sky, Sky, c, 0, 1)
  SkyVertex(12) = LVertex(-Sky, Sky, Sky, c, 0, 0)

  'back
  SkyVertex(14) = LVertex(Sky, -Sky, -Sky, c, 1, 1)
  SkyVertex(13) = LVertex(Sky, Sky, -Sky, c, 1, 0)
  SkyVertex(16) = LVertex(Sky, -Sky, Sky, c, 0, 1)
  SkyVertex(15) = LVertex(Sky, Sky, Sky, c, 0, 0)

  'up
  SkyVertex(18) = LVertex(-Sky, -Sky, -Sky, c, 1, 1)
  SkyVertex(17) = LVertex(Sky, -Sky, -Sky, c, 0, 1)
  SkyVertex(20) = LVertex(-Sky, -Sky, Sky, c, 1, 0)
  SkyVertex(19) = LVertex(Sky, -Sky, Sky, c, 0, 0)
 
  'down
  SkyVertex(21) = LVertex(-Sky, Sky, -Sky, c, 1, 1)
  SkyVertex(22) = LVertex(Sky, Sky, -Sky, c, 0, 1)
  SkyVertex(23) = LVertex(-Sky, Sky, Sky, c, 1, 0)
  SkyVertex(24) = LVertex(Sky, Sky, Sky, c, 0, 0)
 
End Sub
Public Function LoadTerrain(HeightMapFilename As String, Precision As Integer, YFactor, Name As String) As Terrain
   Set LoadTerrain = New Terrain
   LoadTerrain.LoadTerrain HeightMapFilename, Precision, YFactor, 1, 1, TV_LVERTEX
End Function


Public Function LoadTexture(filename As String, Optional width As Integer, Optional height As Integer) As texture
 Set LoadTexture = New texture
 If UCase(Right(filename, 3)) = "GIF" Or UCase(Right(filename, 3)) = "JPG" Then
  LoadTexture.LoadFromJPGGIF filename, width, height, 1
 Else
  LoadTexture.LoadFromBMP filename, width, height, 1
 End If
End Function




Sub RenderAllMeshes()
  ModuleRenderAllMeshes
End Sub

Sub RenderSceneMesh()
  SceneMesh.RenderMesh
End Sub

Sub RenderSky()
 DirectX.IdentityMatrix SkyMatrix
 SkyMatrix = MTranslate(SkyMatrix, StartPos.x, StartPos.y, StartPos.z)
 Device.SetTransform D3DTRANSFORMSTATE_WORLD, SkyMatrix
 Device.SetRenderState D3DRENDERSTATE_LIGHTING, False
 For i = 1 To 6
  Device.SetTexture 0, SkyTexture(i)
  Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, SkyVertex(i * 4 - 3), 4, D3DDP_DEFAULT
 Next i
End Sub

Sub SetCamera(OriginX, OriginY, OriginZ, ToX, ToY, ToZ)
  SetCameraLookAt ToX, ToY, ToZ
  SetCameraPosition OriginX, OriginY, OriginZ
  DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
  
End Sub

Public Sub SetCameraDetails(CameraVectorUp As D3DVECTOR, Optional CameraRoll As Single)
 VectorUp = CameraVectorUp
 If IsMissing(Roll) = False Then Roll = CameraRoll
   DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
End Sub

Public Sub SetCameraLookAt(x, y, z)
 EndPos = Vector(x, y, z)
   DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll
End Sub

Sub SetCameraPosition(x, y, z)
 StartPos = Vector(x, y, z)
  DirectX.ViewMatrix ViewMatrix, StartPos, EndPos, VectorUp, Roll

End Sub

Sub SetCameraRotation(DegreesX As Single, DegreesY As Single)
  SetCameraLookAt StartPos.x + Cos(DegreesX * 3.1415 / 180), StartPos.y + Sin(DegreesY * 3.1415 / 180), StartPos.z + Sin(DegreesX * 3.1415 / 180)
End Sub

Sub SetDetectCollisionPrecision(Precision As Single)
 PrecisionCollide = Precision
End Sub

Sub SetRenderMode(RenderMode As EnumRenderMode)
 If RenderMode = TV_POINT Then
  Device.SetRenderState D3DRENDERSTATE_FILLMODE, D3DFILL_POINT
 End If
 If RenderMode = TV_SOLID Then
  Device.SetRenderState D3DRENDERSTATE_FILLMODE, D3DFILL_SOLID
 End If
 If RenderMode = TV_WIREFRAME Then
  Device.SetRenderState D3DRENDERSTATE_FILLMODE, D3DFILL_WIREFRAME
 End If
End Sub

Sub SetSceneBackground(r, g, b, a)
 BackGround = DirectX.CreateColorRGBA(r, g, b, a)
End Sub


Public Sub SetViewFrustum(FarPlaneSingle As Single, DegreesFOVAngle As Single)
 DirectX.ProjectionMatrix ProjectionMatrix, 1, FarPlaneSingle, DegreesFOVAngle * 3.141592 / 180
 Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, ProjectionMatrix
 FarPlane = FarPlaneSingle
 FOV = DegreesFOVAngle
End Sub

Private Sub Class_Initialize()
 PrecisionCollide = 1
 Roll = 0
 VectorUp = Vector(0, 1, 0)
End Sub

