VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Screen2D"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"

Private Type Surface
  Surf As DirectDrawSurface7
  width As Integer
  height As Integer
  Active As Boolean
  PositionX As Long
  PositionY As Long
  Trans As Boolean
End Type

Private Surfaces(100) As Surface

Function CreateSurface(width As Long, height As Long) As Integer
 If width <= 0 Or height <= 0 Then Exit Function
 For i = 1 To 100
  If Surfaces(i).Active = False Then Exit For
 Next i
 CreateSurface = i
 cs = i
 Surfaces(cs).Active = True
 Surfaces(cs).width = width
 Surfaces(cs).height = height
 
 Dim ddsd As DDSURFACEDESC2
 ddsd.lFlags = DDSD_HEIGHT Or DDSD_CAPS Or DDSD_WIDTH
 ddsd.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
 ddsd.lWidth = width
 ddsd.lHeight = height
 Set Surfaces(cs).Surf = DD.CreateSurface(ddsd)
End Function

Public Sub DrawBox(x1, Y1, X2, y2, Optional color As Long, Optional SurfaceIndex = 0)
 
 If SurfaceIndex = 0 Then
   BackBuffer.DrawBox x1, Y1, X2, y2
   If IsMissing(color) = False Then BackBuffer.SetForeColor color
 Else
  Surfaces(SurfaceIndex).Surf.DrawBox x1, Y1, X2, y2
  If IsMissing(color) = False Then Surfaces(SurfaceIndex).Surf.SetForeColor color
 End If
End Sub

Public Sub DrawFilledBox(x1, Y1, X2, y2, Optional color As Long, Optional SurfaceIndex)

If SurfaceIndex = 0 Then
If IsMissing(color) = False Then BackBuffer.SetFillColor color
 BackBuffer.SetFillStyle 0
 BackBuffer.DrawBox x1, Y1, X2, y2
Else
If IsMissing(color) = False Then Surfaces(SurfaceIndex).Surf.SetFillColor color
 Surfaces(SurfaceIndex).Surf.SetFillStyle 0
 Surfaces(SurfaceIndex).Surf.DrawBox x1, Y1, X2, y2
End If
End Sub
Public Sub DrawLine(x1, Y1, X2, y2, Optional color As Long, Optional SurfaceIndex = 0)

 If SurfaceIndex = 0 Then
 If IsMissing(color) = False Then BackBuffer.SetForeColor color
 BackBuffer.DrawLine x1, Y1, X2, y2
 Else
 If IsMissing(color) = False Then Surfaces(SurfaceIndex).Surf.SetForeColor color
 Surfaces(SurfaceIndex).Surf.DrawLine x1, Y1, X2, y2
 End If
 
End Sub

Function GetDirectDrawSurface(SurfaceIndex As Integer) As DirectDrawSurface7
  Set GetDirectDrawSurface = Surfaces(SurfaceIndex).Surf
End Function

Function LoadSurface(filename As String, Optional width As Long, Optional height As Long, Optional TransColor As Long) As Integer
   
  
  Dim ddsd As DDSURFACEDESC2
 
 ddsd.lFlags = DDSD_CAPS
 ddsd.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
 If IsMissing(width) = False And IsMissing(height) = False Then
  ddsd.lFlags = ddsd.lFlags Or DDSD_WIDTH Or DDSD_HEIGHT
  ddsd.lWidth = width
  ddsd.lHeight = height
 End If
 
 For i = 1 To 100
  If Surfaces(i).Active = False Then Exit For
 Next i
 
 LoadSurface = i
 cs = i
 
 Surfaces(cs).Active = True
 Surfaces(cs).width = width
 Surfaces(cs).height = height
 
 'test for PAK files
 TestPAKFile filename
 'load the bitmap
 Set Surfaces(cs).Surf = DD.CreateSurfaceFromFile(filename, ddsd)
 'if the file was extracted from the pak, delete it
 DeletePAKTemp filename
  
 If IsMissing(TransColor) = False Then
  Dim ck As DDCOLORKEY
  ck.low = TransColor
  ck.high = TransColor
  Surfaces(cs).Surf.SetColorKey DDCKEY_SRCBLT, ck
  Surfaces(cs).Trans = True
 End If
  
End Function

Public Sub RenderBlt(SurfaceIndex, DestX, DestY, DestWidth, DestHeight, SrcX, SrcY, SrcWidth, SrcHeight)
  If Surfaces(SurfaceIndex).Trans = True Then
  BackBuffer.Blt REC(DestX, DestY, DestX + DestWidth, DestY + DestHeight), Surfaces(SurfaceIndex).Surf, REC(SrcX, SrcY, SrcWidth + SrcX, SrcHeight + SrcY), DDBLT_WAIT Or DDBLT_KEYSRC
  Else
  BackBuffer.Blt REC(DestX, DestY, DestX + DestWidth, DestY + DestHeight), Surfaces(SurfaceIndex).Surf, REC(SrcX, SrcY, SrcWidth + SrcX, SrcHeight + SrcY), DDBLT_WAIT
  End If
End Sub

Public Sub RenderSurface(SurfaceIndex, PositionX, PositionY)
 If Surfaces(SurfaceIndex).Trans = True Then
  BackBuffer.BltFast PositionX, PositionY, Surfaces(SurfaceIndex).Surf, REC(0, 0, 0, 0), DDBLTFAST_WAIT
 Else
  BackBuffer.BltFast PositionX, PositionY, Surfaces(SurfaceIndex).Surf, REC(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
 End If
End Sub
Public Sub RenderSurfacePart(SurfaceIndex, PositionX, PositionY, SourceX, SourceY, SourceWidth, SourceHeight)
  If Surfaces(SurfaceIndex).Trans = True Then
  BackBuffer.BltFast PositionX, PositionY, Surfaces(SurfaceIndex).Surf, REC(SourceX, SourceY, SourceWidth + SourceX, SourceHeight + SourceY), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
  Else
  BackBuffer.BltFast PositionX, PositionY, Surfaces(SurfaceIndex).Surf, REC(SourceX, SourceY, SourceWidth + SourceX, SourceHeight + SourceY), DDBLTFAST_WAIT
  End If
End Sub

Public Sub SelectFont(Optional SurfaceIndex = 0, Optional FontName As String, Optional FontSize As Single, Optional FontBold As Boolean, Optional FontUnderLine As Boolean, Optional FontItalic As Boolean)
 If Not IsMissing(FontName) Then Form1.FontName = FontName
 If Not IsMissing(FontBold) Then Form1.FontBold = FontBold
 If Not IsMissing(FontItalic) Then Form1.FontItalic = FontItalic
 If Not IsMissing(FontSize) Then Form1.FontSize = FontSize
 If Not IsMissing(FontUnderLine) Then Form1.FontUnderLine = FontUnderLine
 If SurfaceIndex = 0 Then
 BackBuffer.SetFont Form1.Font
 Else
 Surfaces(SurfaceIndex).Surf.SetFont Form1.Font
 End If
End Sub
Public Sub SetDrawColor(color As Long, Optional SurfaceIndex = 0)
 If SurfaceIndex = 0 Then
  BackBuffer.SetForeColor color
 Else
  Surfaces(SurfaceIndex).Surf.SetForeColor color
 End If
End Sub

Public Sub WriteText(Text As String, x As Single, y As Single, Optional SurfaceIndex As Integer = 0)
 If Text <> "" Then
  If SurfaceIndex = 0 Then
   BackBuffer.DrawText x, y, Text, False
  Else
   Surfaces(SurfaceIndex).Surf.DrawText x, y, Text, False
  End If
 End If
End Sub


