VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SoundEngine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'------------------------------------------------------------------------
' DirectSound Module pour 3D / for 3D (beta version for Explosion Example)
'------------------------------------------------------------------------
'
' Sylvain Dupont @ December 1999.
'
'
' Le coin des dveloppeurs de Jeux 3D    http://francis.dupont.free.fr/coindev/
' The corner of developers of games 3D   http://francis.dupont.free.fr/coindev/english/
'


Sub Play(numbuffer, Optional Looping As Boolean)
 If IsMissing(Looping) = True Then
  DSB(numbuffer).Play DSBPLAY_DEFAULT
 Else
  If Looping = False Then
    DSB(numbuffer).Play DSBPLAY_DEFAULT
   Else
    DSB(numbuffer).Play DSBPLAY_LOOPING
   End If
 End If
 
End Sub

Sub SetCameraListener()
  SetListenerPosition StartPos.x, StartPos.y, StartPos.z
  SetListenerOrientation Cos(GetCameraAngle * 3.14 / 180), 0, Sin(GetCameraAngle * 3.14 / 180), 0, 1, 0
End Sub

Sub SetFormat(buffer As Integer, samplerate As Long, bits As Integer)
  Dim wf2 As WAVEFORMATEX
  wf2.lSamplesPerSec = samplerate
  wf2.nBitsPerSample = bits
  
   DSB(buffer).SetFormat wf2
End Sub

Sub SetFrequency(buffer As Integer, frequency As Long)
  DSB(buffer).SetFrequency frequency
End Sub

Sub SetOrientation(buffer As Integer, x As Single, y As Single, z As Single)
  DSB3D(buffer).SetConeOrientation x, y, z, DS3D_IMMEDIATE
End Sub
Sub SetVolume(buffer As Integer, volume As Long)
  DSB(buffer).SetVolume volume
End Sub

Sub StopBuffer(numbuffer)
 DSB(numbuffer).Stop
End Sub

Sub InitDirectSound()
 Set DS = DirectX.DirectSoundCreate("")
 DS.SetCooperativeLevel Form1.hwnd, DSSCL_NORMAL
 desc.lFlags = DSBCAPS_CTRL3D Or DSBCAPS_PRIMARYBUFFER
 Set DSPrimary = DS.CreateSoundBuffer(desc, WF)
 Set DSListener3D = DSPrimary.GetDirectSound3DListener()
 DSListener3D.SetRolloffFactor 5, DS3D_IMMEDIATE
 DSListener3D.SetVelocity 3, 2, 0, DS3D_IMMEDIATE
 DSListener3D.SetPosition 0, 0, 0, DS3D_IMMEDIATE
 DSListener3D.SetDopplerFactor 1, DS3D_IMMEDIATE
 DSListener3D.SetOrientation 0, 0, 1, 0, 1, 0, DS3D_IMMEDIATE
 
 DSPrimary.Play DSBPLAY_LOOPING
End Sub


Function LoadWave(filename As String, Optional Use3DBuffer As Boolean) As Integer
 If Not IsMissing(Use3DBuffer) = True Then d3 = DSBCAPS_CTRL3D Else d3 = 0
 For i = 1 To 50
  If buffer(i) <> True Then Exit For
 Next i
 
  numbuffer = i
    desc.lFlags = (d3 Or DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME) Or DSBCAPS_STATIC
  
  'Test for PAK file
  TestPAKFile filename
  Set DSB(numbuffer) = DS.CreateSoundBufferFromFile(filename, desc, WF)
  DeletePAKTemp filename
  
  buffer(numbuffer) = True
  LoadWave = numbuffer
  If d3 <> 0 Then
  Set DSB3D(numbuffer) = DSB(numbuffer).GetDirectSound3DBuffer
  End If
End Function


Sub SetListenerOrientation(x As Single, y As Single, z As Single, xt As Single, yt As Single, zt As Single)
 DSListener3D.SetOrientation x, y, z, xt, yt, zy, DS3D_IMMEDIATE
End Sub

Sub SetListenerPosition(x As Single, y As Single, z As Single)
 DSListener3D.SetPosition x, y, z, DS3D_IMMEDIATE
End Sub
Sub SetPosition(buffer As Integer, x As Single, y As Single, z As Single)
 DSB3D(buffer).SetPosition x, y, z, DS3D_IMMEDIATE
End Sub
Private Sub FinDirectSound()
 For i = 1 To NDSB
  Set DSB(i) = Nothing
  Set DSB3D(i) = Nothing
 Next i
 DS.SetCooperativeLevel Form1.hwnd, DSSCL_NORMAL
 Set DS = Nothing
End Sub



Private Sub Class_Terminate()
 FinDirectSound
End Sub


