VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Terrain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'-----------------------------
'  TrueVision v0.5 : Terrain
'-----------------------------
'
' 28-05-2000 : Water bug fixed


Private TXT As Integer
Private O As TerrainType

Private width As Integer, Height As Integer, StepX, StepY


Public Type Water
 Altitude As Single
 Alphablended As Boolean
 AlphaFactor As Single
 Enabled As Boolean
 texture As Integer
 Animated As Boolean
 AnimKey As Single
 TextureScale As Single
 Vertex(4) As D3DLVERTEX
End Type



Public Type TerrainType
 Map() As Single
 Vertex() As D3DVERTEX
 LVertex() As D3DLVERTEX
 VertexIndex() As Integer
 VT As Integer
 Material As D3DMATERIAL7
 Matrix As D3DMATRIX
 Center As D3DVECTOR
 Radius As Single
 WaterEffect As Water
End Type


Public Visible As Integer
Private MaterialIndex As Integer

Public Enum EnumVertexType
  TV_LVERTEX = 1
  TV_VERTEX = 2
  TV_TLVERTEX = 3
End Enum


Function CheckIfVisible() As Boolean
   'the great visibility check with the sphere!
   'mesh sphere must be computed before calling this function
   
   CheckIfVisible = False
  clipstatus = Device.ComputeSphereVisibility(O.Center, O.Radius)
 If clipstatus And &HFFF000 Then
   'not visible
   Visible = 0
 Else
  If clipstatus And &HFFF Then
   'partially visible :
   CheckIfVisible = True
   Visible = 1
  Else
   CheckIfVisible = True
   'entirely visible
   Visible = 2
 End If
 
 End If
End Function

Function DetectCollision(Origin As D3DVECTOR, dest As D3DVECTOR)
   Dim t As Double, U As Double, v As Double, t1 As Double, u1 As Double, v1 As Double
     
    'compute the ray direction
    dest = VSubtract(dest, Origin)
    DirectX.VectorNormalize dest
    
    'compute the position of the player on the terrain
    xpos = Int((Origin.x - O.LVertex(1).x) / StepX)
    ypos = Int((Origin.z - O.LVertex(1).z) / StepY)
   
    
   For x = xpos - 1 To xpos + 1
    For y = ypos - 1 To ypos + 1
     If y >= 0 And y < Height - 1 And x > 1 And x < width Then
       'select the good vertexes
       v3 = (x - 1) * Height + y
       v2 = x * Height + y
       v1 = (x - 1) * Height + y + 1
       v6 = x * Height + y
       v5 = x * Height + y + 1
       v4 = (x - 1) * Height + y + 1
     
       g = Ray_Tri(Origin, dest, vert(O.LVertex(v1)), vert(O.LVertex(v2)), vert(O.LVertex(v3)), t, U, v)
       g1 = Ray_Tri(Origin, dest, vert(O.LVertex(v4)), vert(O.LVertex(v5)), vert(O.LVertex(v6)), t1, u1, v1)
     
       If (g = 1 And t < PrecisionCollide And t >= 0) Or (g1 = 1 And t1 < PrecisionCollide And t1 >= 0) Then
         DetectCollision = True
       Exit Function
      End If
     End If
    Next y
   Next x
  
End Function


Function GetHeight(ByVal x As Single, ByVal z As Single) As Single
  
 'still a great accurate thing !
 
  Dim t As Double, U As Double, v As Double, t1 As Double, u1 As Double, v1 As Double
  Dim dest As D3DVECTOR
  Dim Origin As D3DVECTOR
   
   'calculate the ray direction (bottom --> top)
   Origin = Vector(x, 0, z)
   dest = Vector(0, 1, 0)

    DirectX.VectorNormalize dest
    
    'compute the position of the player on the terrain
    xpos = Int((Origin.x - O.LVertex(1).x) / StepX)
    ypos = Int((Origin.z - O.LVertex(1).z) / StepY)
   
    
   For xq = xpos - 1 To xpos + 1
    For yq = ypos - 1 To ypos + 1
     If yq >= 0 And yq < Height - 1 And xq > 1 And xq < width Then
     'select good vertexes
     v3 = (xq - 1) * Height + yq
     v2 = xq * Height + yq
     v1 = (xq - 1) * Height + yq + 1
     v6 = xq * Height + yq
     v5 = xq * Height + yq + 1
     v4 = (xq - 1) * Height + yq + 1
     
     g = Ray_Tri(Origin, dest, vert(O.LVertex(v1)), vert(O.LVertex(v2)), vert(O.LVertex(v3)), t, U, v)
     g1 = Ray_Tri(Origin, dest, vert(O.LVertex(v4)), vert(O.LVertex(v5)), vert(O.LVertex(v6)), t1, u1, v1)
     
     If (g = 1 And t >= 0) Or (g1 = 1 And t1 >= 0) Then
     'if we have a collision (I hope we'll have a collision else we'll a big problem : GetHeight = 00)
     If t = 0 Then GetHeight = t1 Else GetHeight = t
     Exit Function
    End If
   End If
    Next yq
   Next xq
Exit Function


End Function

Public Sub LoadTerrain(HeightMapFile As String, Precision, YFactor, tu As Single, tv As Single, Optional vertextype As EnumVertexType)
  If IsMissing(vertextype) = True Then vertextype = TV_LVERTEX
  DirectX.IdentityMatrix O.Matrix
  On Error GoTo 0
   '----------------
  ' Load the terrain from a height surface
  ' Charge le terrain  partir d'une surface de hauteur.
  '------------------
  Form1.Pict.Visible = True
  
  ' Load the height surface in a PictureBox / Charge l'image "relief" dans un PictureBox
  TestPAKFile HeightMapFile
  Form1.Pict.Picture = LoadPicture(HeightMapFile)
  DeletePAKTemp HeightMapFile
 
  ' Compute rows and columns / Calcule le nombre de ranges et de colonnes
  mapx = Int(Form1.Pict.ScaleWidth / Precision)
  mapy = Int(Form1.Pict.ScaleHeight / Precision)
  StepX = Precision
  StepY = Precision
  width = mapx
  Height = mapy
  'Dim Arrays / Redimensionne les tableaux
  
  ReDim O.Map(mapx, mapy)
  ReDim O.Vertex(mapx * mapy)
  ReDim O.LVertex(mapx * mapy)
  
   '
   '
   ' bounding box
   Dim min As D3DVECTOR
   Dim max As D3DVECTOR
   min = Vector(99999999, 999999999, 999999999)
   max = Vector(-999999999, -999999999, -999999999)
     
   h = 0
   'For each point in the surface  / Pour chaque point dans la surface
   For x = 1 To mapx
   
    For y = 1 To mapy
     'Find the color of the point / Trouve la couleur du point
      O.Map(x, y) = Form1.Pict.Point((x - 1) * Precision, (y - 1) * Precision) Mod 256
     'Change Index / Incrmente l'index
      h = h + 1
      
      'Compose the D3DLVERTEX / Compose le vertex
       U = x / mapx * tu
       v = y / mapy * tv

       O.Vertex(h) = Vertex(x * Precision, YFactor * O.Map(x, y), y * Precision, 0, 1, 0, U, v)
       O.LVertex(h) = LVertex(x * Precision, YFactor * O.Map(x, y), y * Precision, DirectX.CreateColorRGBA(1, 1, 1, 1), U, v)
      With O.LVertex(h)
       If .x > max.x Then max.x = .x
       If .y > max.y Then max.y = .y
       If .z > max.z Then max.z = .z
       If .x < min.x Then min.x = .x
       If .y < min.y Then min.y = .y
       If .z < min.z Then min.z = .z
      End With
 
    Next y
   Next x
   j = 0
  ' AddLog "Vert done"
   ' Now Indexes for DrawIndexedPrimitive / Maintenant les index pour la mthode DrawIndexedPrimitive
   ' 2 Triangles per face / 2 triangles par face
   ReDim O.VertexIndex(mapx * mapy * 6)
   For x = 1 To mapx - 1
    For y = 1 To mapy - 1
     O.VertexIndex(j + 2) = (x - 1) * mapy + y
     O.VertexIndex(j + 1) = x * mapy + y
     O.VertexIndex(j + 0) = (x - 1) * mapy + y + 1
     O.VertexIndex(j + 5) = x * mapy + y
     O.VertexIndex(j + 4) = x * mapy + y + 1
     O.VertexIndex(j + 3) = (x - 1) * mapy + y + 1
     j = j + 6
    Next y
   Next x
   ReDim Preserve O.VertexIndex(j - 1)
   
   'compute sphere
   '
     Dim Rad As D3DVECTOR
   Rad.x = Abs((max.x - min.x) / 2)
   Rad.y = Abs((max.y - min.y) / 2)
   Rad.z = Abs((max.z - min.z) / 2)
 O.Center = Vector((max.x + min.x) / 2, (max.y + min.y) / 2, (max.z + min.z) / 2)
 'take the most big radius
 If Rad.x >= Rad.y And Rad.x >= Rad.z Then
  O.Radius = Rad.x * Sqr(2)
 End If
 If Rad.y >= Rad.x And Rad.y >= Rad.z Then
  O.Radius = Rad.y * Sqr(2)
 End If
 If Rad.z >= Rad.x And Rad.z >= Rad.y Then
  O.Radius = Rad.z * Sqr(2)
 End If
 
 AddLog "Terrain Sphere computed :" + CStr(O.Radius) + " at " + CStr(O.Center.x) + " " + CStr(O.Center.y) + " " + CStr(O.Center.z)
 
  'AddLog "Vert index done"
  'Disable the PictureBox / Dsactive la PictureBox
  Form1.Pict.Visible = False
  O.VT = vertextype
  
  With O.WaterEffect
   .Vertex(2) = LVertex(0, 0, 0, DirectX.CreateColorRGBA(1, 1, 1, 1), 0, 32)
   .Vertex(1) = LVertex(mapx * StepX, 0, 0, DirectX.CreateColorRGBA(1, 1, 1, 1), 32, 32)
   .Vertex(4) = LVertex(0, 0, mapy * StepY, DirectX.CreateColorRGBA(1, 1, 1, 1), 0, 0)
   .Vertex(3) = LVertex(mapx * StepX, 0, mapy * StepY, DirectX.CreateColorRGBA(1, 1, 1, 1), 32, 0)
  End With
  O.WaterEffect.Altitude = 0
  O.WaterEffect.AnimKey = 0
  O.WaterEffect.TextureScale = 32

'  AddLog "Terrain loaded... " + CStr(O.VT)
End Sub


Public Function LoadTerrainPart(HeightMapFilename As String, PosX As Long, PosY As Long, YFactor As Single, tu, tv, vertextype As EnumVertexType)

End Function

Public Sub RenderAll()
 Device.SetTransform D3DTRANSFORMSTATE_WORLD, O.Matrix
 If CheckIfVisible = 0 Then Exit Sub
 If TXT = 0 Then
   Device.SetTexture 0, Nothing
 Else '
   Device.SetTexture 0, texture(TXT)
 End If
 Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
 If O.VT = TV_VERTEX Then
  Device.SetRenderState D3DRENDERSTATE_LIGHTING, True
   Device.SetMaterial Material(MaterialIndex).Material
   Device.DrawIndexedPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, O.Vertex(0), UBound(O.Vertex), O.VertexIndex(), UBound(O.VertexIndex) - 2, D3DDP_DEFAULT
 Else
 Device.SetRenderState D3DRENDERSTATE_LIGHTING, False
   Device.DrawIndexedPrimitive D3DPT_TRIANGLELIST, D3DFVF_LVERTEX, O.LVertex(0), UBound(O.LVertex), O.VertexIndex(), UBound(O.VertexIndex) - 2, D3DDP_DEFAULT
 End If
 
 'render water effect
 If O.WaterEffect.Enabled = True Then
  Device.SetRenderState D3DRENDERSTATE_LIGHTING, False
  If O.WaterEffect.texture > 0 Then
   Device.SetTexture 0, texture(O.WaterEffect.texture)
  Else
   Device.SetTexture 0, Nothing
  End If
  If O.WaterEffect.Animated = True Then
   O.WaterEffect.AnimKey = O.WaterEffect.AnimKey + SystemFrame * 0.001
   a = O.WaterEffect.AnimKey: st = O.WaterEffect.TextureScale
   'calculate Water "animation"
   O.WaterEffect.Vertex(1).tu = st + Cos(a) * st / 100
   O.WaterEffect.Vertex(1).tv = st
   O.WaterEffect.Vertex(2).tu = 0 + Cos(a) * st / 100
   O.WaterEffect.Vertex(2).tv = st
   O.WaterEffect.Vertex(3).tu = st + Cos(a) * st / 100
   O.WaterEffect.Vertex(3).tv = 0
   O.WaterEffect.Vertex(4).tu = 0 + Cos(a) * st / 100
   O.WaterEffect.Vertex(4).tv = 0
  If a > 360 Then O.WaterEffect.AnimKey = -360
  End If
  'alpha setting
  Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, O.WaterEffect.Alphablended
  Device.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA
  Device.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE
  
  'water rendering
  Device.DrawPrimitive D3DPT_TRIANGLESTRIP, D3DFVF_LVERTEX, O.WaterEffect.Vertex(1), 4, D3DDP_DEFAULT
 End If
End Sub
Sub SetMaterial(Material As Integer)
  MaterialIndex = Material
End Sub

Public Sub SetPosition(x As Single, y As Single, z As Single)
   Dim ident As D3DMATRIX
   DirectX.IdentityMatrix ident
   O.Matrix = MTranslate(ident, x, y, z)
End Sub

Public Sub SetTexture(Text As texture)
 TXT = Text.TextureIndex
End Sub


Public Sub SetTextureCoordinates(tu, tv)
  h = 0
     For x = 1 To width
    For y = 1 To Height
      h = h + 1
       U = x / width * tu
       v = y / Height * tv
       O.Vertex(h).tu = U
       O.Vertex(h).tv = v
       O.LVertex(h).tu = U
       O.LVertex(h).tv = v
    Next y
   Next x
End Sub


Sub SetVertexType(vertextype As EnumVertexType)
 O.VT = vertextype
End Sub


Sub SetWaterAltitude(Altitude As Single)
 O.WaterEffect.Altitude = Altitude
 For i = 1 To 4
  O.WaterEffect.Vertex(i).y = Altitude
 Next i
End Sub


Sub SetWaterEffect(alpha As Boolean, Optional AlphaFactor As Single = 0.4, Optional Animated As Boolean = False)
 O.WaterEffect.Alphablended = alpha
 O.WaterEffect.Animated = Animated
 O.WaterEffect.AlphaFactor = AlphaFactor
 For i = 1 To 4
  O.WaterEffect.Vertex(i).Color = DirectX.CreateColorRGBA(1, 1, 1, AlphaFactor)
 Next i
 
End Sub

Sub SetWaterEnable(OnOff As Boolean)
 O.WaterEffect.Enabled = True
End Sub

Sub SetWaterTexture(texture As texture)
 O.WaterEffect.texture = texture.TextureIndex
End Sub


Sub SetWaterTextureScale(ScaleTexture As Single)
  If O.WaterEffect.Animated = False Then
  For i = 1 To 4
   O.WaterEffect.Vertex(i).tu = Sgn(O.WaterEffect.Vertex(i).tu) * ScaleTexture
   O.WaterEffect.Vertex(i).tv = Sgn(O.WaterEffect.Vertex(i).tv) * ScaleTexture
  Next i
 
  End If
  O.WaterEffect.TextureScale = ScaleTexture
End Sub


