Attribute VB_Name = "TVGeneralModule"
'---------------------------------------------------------------
'
' <<<<<<<<<<<<<<<<<  TRUE VISION ENGINE  >>>>>>>>>>>>>>>>>>>>>>
'
'--------------------------------------------------------------

'~ by Sylvain Dupont & Christopher D. Parker ~
' CDVG - http://francis.dupont.free.fr/coindev/english/
'      - http://www.cdvg.org

' Often updated !!



'-------------------
' Engine version
'------------------
Global Const ENGINE_VERSION = 0.9
'
' DirectX & others objects declaration
'
Public DirectX As New DirectX7
Public DD As DirectDraw7
Public D3DIM As Direct3D7
Public Device As Direct3DDevice7
Public Primary As DirectDrawSurface7
Public BackBuffer As DirectDrawSurface7
Public Hardware As Boolean
Public DeviceGUID As String
Public ZBufferUse As Boolean
Public DisplayFPS2 As Boolean
Public BBDDSD As DDSURFACEDESC2
Public ZBuffer As DirectDrawSurface7
Public Clipper As DirectDrawClipper
Public Console As DirectDrawSurface7
Public KeyConsole As Long

Public FarPlane As Single, FOV As Single
Public WorldMatrix As D3DMATRIX
Public ViewMatrix As D3DMATRIX
Public ProjectionMatrix As D3DMATRIX
Public Memory
Public DescDevice As D3DDEVICEDESC7

Public OldTime As Single, FPS As Single, SystemFrame As Single, OldFPS As Single, NBImage As Integer, Windowed As Boolean, WindowHandle

Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Public Declare Function SetCursorPos Lib "user32" (ByVal x As Long, ByVal y As Long) As Long


Public DI As DirectInput
Public DIDevice As DirectInputDevice
Public KeyStateDI As DIKEYBOARDSTATE

Public CLR(1) As D3DRECT
Public texture(100) As DirectDrawSurface7
Public TextureName(100) As String

Public ViewPort As D3DVIEWPORT7

Public KeyState(255) As Boolean
Public ShiftKey As Integer
Public MouseX As Single, MouseY As Single, MouseButton As Integer

Public DS As DirectSound



' camera, see Camera class
Public StartPos As D3DVECTOR
Public EndPos As D3DVECTOR
Public Roll As Single
Public VectorUp As D3DVECTOR
'-------
Public BackGround As Long

Public Type FaceIndexType
  FaceIndex() As Integer
  FaceIndexCount As Long
  texture As Integer
End Type

Public Type BoneType
 Pos As D3DVECTOR
 Rot As D3DVECTOR
 Parent As Integer
 Name As String
 NowPos As D3DVECTOR
 NowRot As D3DVECTOR
 Matrix As D3DMATRIX
End Type

Public Type FrameType
 BonesPosition() As D3DVECTOR
 BonesRotation() As D3DVECTOR
End Type

Public Type SingleAnimType
 frame() As FrameType
 NBFrame As Integer
 Name As String
 LV() As D3DLVERTEX
End Type

Public Type AnimationType
 Bones() As BoneType
 VertexBones() As Integer
 NbBones As Integer
 Animation() As SingleAnimType
 CurrentKey As Single
End Type

Public Type MType
  Vertex() As D3DVERTEX
  LVertex() As D3DLVERTEX
  TLVertex() As D3DTLVERTEX
  GroupIndex() As FaceIndexType
  GroupIndexCount As Integer
  Anim As AnimationType
  Color As Integer
  Active As Boolean
  vertextype As Integer
  TextureI As Integer
  UseIndexes As Boolean
  Center As D3DVECTOR
  radius As Single
  BBoxMin As D3DVECTOR
  BBoxMax As D3DVECTOR
End Type

Public Mesh(1000) As MType
Const EPSILON = 0.0001
Public PrecisionCollide As Single

Const NDSB = 50 'max sound buffers

Public AppPath As String

Public DSB(1 To NDSB) As DirectSoundBuffer
Public DSB3D(1 To NDSB) As DirectSound3DBuffer
Public DSListener3D As DirectSound3DListener
Public DSPrimary As DirectSoundBuffer

Public desc As DSBUFFERDESC
Public WF As WAVEFORMATEX

Public buffer(1 To NDSB) As Boolean

'Global Const TV_VERTEX = 1
'Global Const TV_LVERTEX = 2
'Global Const TV_TLVERTEX = 3
Global Const TV_PARTICLE_EXPLOSION = 1
Global Const TV_PARTICLE_FORCEFIELD = 2


Public Type ParticleA
 Rotation As D3DVECTOR
 
 LifeTime As Single
 TimeAct As Single
 Direction As D3DVECTOR
 Active As Boolean
End Type


Public Type ParticleSystem
  Particle() As ParticleA
  NbParticle As Integer
  type As Integer
  Vertex() As D3DLVERTEX
  Tri() As D3DLVERTEX
  UseBillboard As Boolean
  Speed As Single
  Gravity As Single
  radius As Single
  Position As D3DVECTOR
  Active As Boolean
  Color As Long
  GenerateSpeed As Single
  Direction As D3DVECTOR
End Type

Public Type LightType
 Active As Boolean
 Enabled As Boolean
 Light As D3DLIGHT7
End Type

Public Light(100) As LightType

Public Type MaterialType
 Active As Boolean
 Enabled As Boolean
 Material As D3DMATERIAL7
End Type

'Public ParticuleDescription


Public Material(100) As MaterialType

Public Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As Any) As Long ' lpPoint As POINTAPI

Private Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Public SceneMesh As New Mesh

'-------------------------
' PAK files Declarations
'------------------------------

Public Type FileInPAK
   named As String * 56
   filepos As Long
   filelen As Long
End Type
 
Public Type PAKFileHeader
  ident As Long
  dirofs As Long
  dirlen As Long
End Type

Const MAX_FILES_IN_PACK = 4096


Public PakHeader As PAKFileHeader
Public PakFiles(MAX_FILES_IN_PACK) As FileInPAK
Public NumPakFiles As Integer
Public PakPath As String * 64
Public FileToDelete As Boolean

Public FileLoaded() As String
Public PakEnable As Boolean, NBFileInPak
Public Function GetCameraAngle() As Single
 Dim v As D3DVECTOR
 v = VSubtract(EndPos, StartPos)
 
 If v.z > 0 Then
  GetCameraAngle = Atn(v.x / v.z)
 ElseIf v.z = 0 Then
  GetCameraAngle = 0
 Else
  GetCameraAngle = Atn(v.x / v.z) + 3.141592
 End If
  
  GetCameraAngle = GetCameraAngle * 180 / 3.141592

End Function
Public Function GetCameraAngleX() As Single
 Dim v As D3DVECTOR
 v = VSubtract(EndPos, StartPos)
 
 If v.y > 0 Then
  GetCameraAngleX = Atn(v.y / v.x)
 ElseIf v.y = 0 Then
  GetCameraAngleX = 0
 Else
  GetCameraAngleX = Atn(v.y / v.x) + 3.141592
 End If
  
  GetCameraAngleX = GetCameraAngleX * 180 / 3.141592

End Function
Public Function CreateSurfaceFromFile(ByVal filename As String, SurfaceDesc As DDSURFACEDESC2) As DirectDrawSurface7
On Error GoTo errs
    Dim Picture As StdPicture
    Dim width As Long
    Dim height As Long
    Dim Surface As DirectDrawSurface7
    Dim hdcPicture As Long  ' Picture device context
    Dim hdcSurface As Long  ' Surface device context
    ' Load picture
    Set Picture = LoadPicture(filename)
    ' Convert from vbHimetric to vbPixels
    width = CLng((Picture.width * 0.001) * 567 / Screen.TwipsPerPixelX)
    height = CLng((Picture.height * 0.001) * 567 / Screen.TwipsPerPixelY)
    ' Update surface description
    With SurfaceDesc
        If .lFlags = 0 Then .lFlags = DDSD_CAPS
        .lFlags = .lFlags Or DDSD_WIDTH Or DDSD_HEIGHT
        If .ddsCaps.lCaps = 0 Then .ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
        If .lWidth = 0 Then .lWidth = width
        If .lHeight = 0 Then .lHeight = height
    End With
    ' Create surface
    Set Surface = DD.CreateSurface(SurfaceDesc)
    ' Create memory device
    hdcPicture = CreateCompatibleDC(0)
    ' Select the bitmap in this memory device
    SelectObject hdcPicture, Picture.Handle
    ' Get the surface's DC
    hdcSurface = Surface.GetDC
    ' Copy from the memory device to the DirectDrawSurface
    StretchBlt hdcSurface, 0, 0, SurfaceDesc.lWidth, SurfaceDesc.lHeight, hdcPicture, 0, 0, width, height, vbSrcCopy
    ' Release the surface's DC
    Surface.ReleaseDC hdcSurface
    ' Release the memory device and the bitmap
    DeleteDC hdcPicture
    Set Picture = Nothing
    Set CreateSurfaceFromFile = Surface
    Set Surface = Nothing
  Exit Function
errs:
  AddLog "Error in Load GIF JPG " + Err.Description + " " + CStr(Err.Number)
 Resume Next
  
End Function



Sub DeletePAKTemp(file As String)
  If file <> "" And PakEnable = True And FileToDelete = True Then
   FileToDelete = False
   'AddLog "Kill " + file
   Kill file
  End If
End Sub

Public Sub FlipToScreen()
TestCooperativeMode
If Windowed = True Then
 Dim re As RECT
  DirectX.GetWindowRect WindowHandle, re
  Primary.Blt re, BackBuffer, REC(0, 0, 0, 0), DDBLT_WAIT
 Else
 Primary.Flip Nothing, DDFLIP_WAIT
 End If

End Sub
Function LoadSimpleTexture(BitmapFile As String, width As Long, height As Long) As DirectDrawSurface7

  
 '  If IsMissing(Width) = True Then w = 0 Else w = Width
 '  If IsMissing(Height) = True Then h = 0 Else h = Height
  ' If IsMissing(ColorKey) = True Then ColorKey = 0
    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim i As Long
    Dim ddsd3 As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean
    On Error GoTo 789
    ddsd3.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If IsMissing(width) Then w = 0: h = 0 Else w = width: h = height
    If ((h <> 0) And (w <> 0)) Then
        ddsd3.lFlags = ddsd3.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        ddsd3.lHeight = h
        ddsd3.lWidth = w
        AddLog "Texture streched :" + CStr(w) + " " + CStr(h)
    End If
    
     
    Set enumTex = Device.GetTextureFormatsEnum()
    
   
    For i = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(i, ddsd3.ddpfPixelFormat)
            
        With ddsd3.ddpfPixelFormat
            
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
            If (.lRGBAlphaBitMask <> 0) Then bOK = False
        End With
        If bOK = True Then Exit For
    Next
    
    If bOK = False Then
         AddLog "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If

    If (((1 And extraFlags) _
          Or (2 And extraFlags))) Then
        ddsd3.ddpfPixelFormat.lFlags = DDPF_ALPHAPIXELS Or DDPF_RGB
        ddsd3.lFlags = ddsd.lFlags Or DDSD_PIXELFORMAT

    Else
       ddsd3.ddpfPixelFormat.lFlags = DDPF_RGB

    End If
    
    ' voodoo 2 change
    If Device.GetDeviceGuid() <> "IID_IDirect3DRGBDevice" Then
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE
            ddsd3.ddsCaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            ddsd3.lTextureStage = 0

    Else
            ddsd3.ddsCaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            ddsd3.ddsCaps.lCaps2 = 0
            ddsd3.lTextureStage = 0

    End If

    If BitmapFile = "" Then
        Set SurfaceObject = DD.CreateSurface(ddsd3)
    Else
        TestPAKFile BitmapFile
        If UCase(Right(BitmapFile, 3)) = "JPG" Or UCase(Right(BitmapFile, 3)) = "GIF" Then
        Set SurfaceObject = CreateSurfaceFromFile(BitmapFile, ddsd3)
        Else
        Set SurfaceObject = DD.CreateSurfaceFromFile(BitmapFile, ddsd3)
        End If
        DeletePAKTemp BitmapFile
    End If
     'AddLog "Result : Create Texture success " + BitmapFile + " " + CStr(ddsd3.ddsCaps.lCaps And DDSCAPS_TEXTURE)
     
     Set LoadSimpleTexture = SurfaceObject
     Exit Function
789:
 AddLog "ERROR : Create surface " + Err.Description + " " + CStr(Err.Number)
 Resume Next
End Function

Sub ModuleRenderAllMeshes()
 For i = 1 To 100
  If Mesh(i).Active = True Then
  
  End If
 Next i
End Sub

'for collision detection ! Find the intersection of a ray with a triangle
Function Ray_Tri(orig As D3DVECTOR, Dir As D3DVECTOR, vert0 As D3DVECTOR, vert1 As D3DVECTOR, vert2 As D3DVECTOR, t As Double, U As Double, v As Double) As Byte
Dim Edge1 As D3DVECTOR
Dim Edge2 As D3DVECTOR
Dim tvec As D3DVECTOR
Dim pvec As D3DVECTOR
Dim qvec As D3DVECTOR
Dim inv_det As Double
Dim det As Double

   '/* find vectors for two edges sharing vert0 *'/
   Edge1 = VSubtract(vert1, vert0)
   Edge2 = VSubtract(vert2, vert0)

   '/* begin calculating determinant - also used to calculate U parameter *'/
   pvec = VCrossProduct(Dir, Edge2)

   '/* if determinant is near zero, ray lies in plane of triangle *'/
   det = VDotProduct(Edge1, pvec)
 
   If det > -EPSILON And det < EPSILON Then
      Ray_Tri = 0
      Exit Function
   End If
   inv_det = 1 / det
   
   'calculate distance from vert0 to ray origin
   tvec = VSubtract(orig, vert0)

   'calculate u parameter and test bounds
   U = VDotProduct(tvec, pvec) * inv_det
   If U < 0 Or U > 1 Then
      Ray_Tri = 0
      Exit Function
   End If
   
   'Prepare to test v parameter
   qvec = VCrossProduct(tvec, Edge1)

   'Calculate v parameter and test bounds
   v = VDotProduct(Dir, qvec) * inv_det
   If v < 0 Or U + v > 1 Then
      Ray_Tri = 0
      Exit Function
   End If
   
   'Calculate t, ray intersects triangle
   t = VDotProduct(Edge2, qvec) * inv_det
       
      Ray_Tri = 1
      'ColScore.t = t
      'ColScore.u = u
      'ColScore.v = v

End Function


Function DXColor(r, g, b, a) As D3DCOLORVALUE
 DXColor.a = a
 DXColor.b = b
 DXColor.g = g
 DXColor.r = r
End Function
Public Sub ErrorGest()
 DD.SetCooperativeLevel Form1.hwnd, DDSCL_NORMAL
 Set DD = Nothing
 Set Primary = Nothing
 Set BackBuffer = Nothing
 Set DirectX = Nothing
 MsgBox "Error in TrueVision Engine / Erreur dans le moteur TrueVision" + Chr(13) + " Err : " + CStr(Err.Number) + Chr(13) + " Error description :" + Err.Description, vbCritical, "TrueVision Engine"
 
 
End Sub

Function SearchClassName() As String
 AddLog "SearchClass Name"
Do
  Line Input #1, ligne
  AddLog CStr(ligne)
  If InStr(UCase(ligne), "CLASSNAME") > 0 Then
    AddLog "found"
    lig = Trim(ligne)
    Classe = Mid(lig, 14)
    Classe = Left(Classe, Len(Classe) - 1)
    Exit Do
  End If
 Loop Until EOF(1)
 If Classe = "" Then Classe = "NO"
 SearchClassName = Classe
End Function

Sub LoadMapFile(filename As String)
  Open filename For Input As 1
   On Error GoTo erre
   Do
      Line Input #1, ligne
      AddLog CStr(ligne)
      If Trim(ligne) = "{" Then
         Classe = SearchClassName
         AddLog "SearchClass " + Classe
         Select Case UCase(Classe)
           Case "WORLDSPAWN"
            AddLog "WorldSpawn"
            SearchWorldSpawn
             
         End Select
      End If
      
      
   Loop Until EOF(1)
   AddLog "End of the Map file parse"
  Close #1
  
erre:
  Close #1
  AddLog "Error in Load Map File " + Err.Description + " " + CStr(Err.Number)
  
End Sub
Function SearchWorldSpawn() As Boolean
 SceneMesh.ClearMesh
 SceneMesh.SetVertexType TV_LVERTEX
 SceneMesh.SetPrimitiveType TV_TRIANGLELIST
 
 Dim v(3) As D3DVERTEX
reg:
 Do
  Line Input #1, lign
  If EOF(1) Or InStr(lign, "}") > 0 Then Exit Function
 Loop Until InStr(lign, "{") > 0
 Do
  If EOF(1) Then Exit Function
  Line Input #1, lign
  lign = Trim(lign)
  If Left(lign, 1) = "(" Then
    rest = lign
    For i = 1 To 3
     re = Mid(rest, InStr(rest, "(") + 1)
     re = Trim(re)
    ' AddLog CStr(re)
     rees = InStr(re, " ") + 1
     AddLog CStr(rees) + " " + CStr(re)
     v(i).x = Val(Left(re, rees - 1))
     re = Mid(re, rees)
     '  AddLog CStr(re)
     rees = InStr(re, " ") + 1
     v(i).y = Val(Left(re, rees - 1))
     re = Mid(re, rees)
     '  AddLog CStr(re)
     rees = InStr(re, " ") + 1
     v(i).z = Val(Left(re, rees - 1))
     rest = Mid(re, rees)
    '   AddLog CStr(rest) + "fin"
     AddLog CStr(v(i).x) + " " + CStr(v(i).y) + " " + CStr(v(i).z)
     SceneMesh.AddVertex v(i).x, v(i).y, v(i).z, DirectX.CreateColorRGBA(1, Rnd, 1, 1), 0, 0, 0, 0, 1
    Next i
  End If
  
 Loop Until InStr(lign, "}") > 0
 GoTo reg
End Function


Sub TestCooperativeMode()
 'We don't have to render if we aren't in exclusive mode
 restore = False
 Do Until DD.TestCooperativeLevel = DD_OK
  DoEvents
  restore = True
 Loop
  'if an other app has taken the focus, we have to all restore
 If restore = True Then
  DD.RestoreAllSurfaces
 End If
End Sub

Sub TestPAKFile(ByRef filename As String)
 On Error GoTo SendError
 'test if we have to extract the file from the PAK
 If PakEnable = True Then
   AddLog "TestPakFile " + filename
   fileindex = -1
   If Dir(filename) = "" Then
     For i = 0 To NBFileInPak
      If UCase(filename) = Trim(UCase(PakFiles(i).named)) Then fileindex = i: Exit For
     Next i
     If fileindex = -1 Then filename = "": AddLog "No found in PAK": Exit Sub
   
     With PakFiles(fileindex)
      filename = Trim(.named)
      'Replace "/" by "\"
       For i = 1 To Len(filename)
         If Mid(filename, i, 1) = "/" Then Mid(filename, i, 1) = "\"
       Next i
    
       'Get the filename without path
       For i = Len(filename) To 1 Step -1
         If Mid(filename, i, 1) = "\" Then Exit For
       Next i
       filename = Mid(filename, i + 1)
    
       Open filename For Binary As 4
       ReDim a(.filelen + 1) As Byte
       Get #80, .filepos + 1, a
       Put #4, , a
       Close #4
       AddLog filename + " has been written"
       FileToDelete = True
     End With
  End If
 End If
Exit Sub
 
SendError:
 AddLog "File in PAK " + filename + " has occured a error :" + Err.Description
 Err.Clear
 
End Sub
Function TLVertex(x, y, z, Color, tu, tv) As D3DTLVERTEX
 TLVertex.sx = x
 TLVertex.sy = y
 TLVertex.sz = z
 TLVertex.Color = Color
 TLVertex.Specular = Color
 TLVertex.rhw = 0.5
 TLVertex.tu = tu
 TLVertex.tv = tv
End Function


Sub AddLog(log As String)
 Open "c:\debug.dat" For Append As 44
  Print #44, log
 Close #44
 
End Sub

Public Function REC(x, y, x1, Y1) As RECT
  REC.Left = x
  REC.Top = y
  REC.Right = x1
  REC.Bottom = Y1
End Function

Public Function LVertex(x, y, z, Color, tu, tv) As D3DLVERTEX
 With LVertex
  .x = x
  .y = y
  .z = z
  .Color = Color
  .Specular = Color
  .tu = tu
  .tv = tv
 End With
End Function

Public Sub SetDefault()
 'set default view frustum
 
 DirectX.ViewMatrix ViewMatrix, Vector(0, 0, -5), Vector(0, 0, 0), Vector(0, 1, 0), 0
 DirectX.ProjectionMatrix ProjectionMatrix, 1, 1000, 3.141592 / 2
 DirectX.IdentityMatrix WorldMatrix
 
 Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, ProjectionMatrix
 Device.SetTransform D3DTRANSFORMSTATE_WORLD, WorldMatrix
 Device.SetTransform D3DTRANSFORMSTATE_VIEW, ViewMatrix
End Sub

Function Vector(x, y, z) As D3DVECTOR
 Vector.x = x
 Vector.y = y
 Vector.z = z
End Function


Function vert(Vertex As D3DLVERTEX) As D3DVECTOR
  vert.x = Vertex.x
  vert.y = Vertex.y
  vert.z = Vertex.z
End Function

Function verte(Vertex As D3DVERTEX) As D3DVECTOR
  verte.x = Vertex.x
  verte.y = Vertex.y
  verte.z = Vertex.z
End Function


Public Function Vertex(x, y, z, nx, ny, nz, tu, tv) As D3DVERTEX
 With Vertex
  .x = x
  .y = y
  .z = z
  .nx = nx
  .ny = ny
  .nz = nz
  .tu = tu
  .tv = tv
 End With
End Function


