VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TrueVision"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Public Enum TrueVisionRenderState
  TV_RENDERSTATE_FILLMODE = 1
  TV_RENDERSTATE_SHADEMODE = 2
  TV_RENDERSTATE_DEST_ALPHABLENDING = 3
  TV_RENDERSTATE_SRC_ALPHABLENDING = 4
  TV_RENDERSTATE_SHOW_SKELETON = 5
  TV_RENDERSTATE_SHOW_DEBUG_INFO = 6
End Enum

Sub ClosePAKFile()
 If PakEnable = True Then
  AddLog "Pak Closed"
  PakEnable = False
  Close 80
 End If
End Sub


'-=========================================
'- AttatchZBuffer
'
'  (A ZBuffer holds state for every pixel rendered
'  indicating what depth the rendered pixel is supposed to
'  represent so that when pixels are rendered on top of it
'  the rendered can decide if the new pixel is behind the
'  all ready rendered one)
'
'-=========================================
Private Function AttatchZBuffer() As Boolean
    On Local Error GoTo errOut
            
    
    Dim hr As Integer
    Dim ddsZBuff  As DirectDrawSurface7
    Dim ddsd As DDSURFACEDESC2
    Dim ddsd2 As DDSURFACEDESC2
    
    Dim l As Long
    Dim i As Long

    m_bClearZ = False
    
    Dim fenum As Direct3DEnumPixelFormats
    Set fenum = D3DIM.GetEnumZBufferFormats(DeviceGUID)
    l = fenum.GetCount()
    
    '-  some cards dont support zbuffering so
    '   we return success here because some cards can do
    '   3d with out none
    If l = 0 Then
        AddLog "Pas de Z-Buffer"
        AttatchZBuffer = True
       Exit Function
     
    End If
    
    '- loop through zbuffer formats and get the first 16 bit one
    '  we find
    For i = 1 To l
        Call fenum.GetItem(i, ddsd2.ddpfPixelFormat)
        If ddsd2.ddpfPixelFormat.lZBufferBitDepth = 16 Then Exit For
    Next
    
    Call BackBuffer.GetSurfaceDesc(ddsd)
                           

    
    ddsd2.lFlags = DDSD_CAPS Or _
                DDSD_WIDTH Or _
                DDSD_HEIGHT Or _
                DDSD_PIXELFORMAT
    ddsd2.ddsCaps.lCaps = ddsd2.ddsCaps.lCaps Or DDSCAPS_ZBUFFER Or Memory
   'AddLog "Width " + CStr(ddsd.lWidth)
   'AddLog "Height " + CStr(ddsd.lHeight)
    ddsd2.lWidth = ddsd.lWidth
    ddsd2.lHeight = ddsd.lHeight
    ddsd2.ddpfPixelFormat.lFlags = DDPF_ZBUFFER Or ddsd2.ddpfPixelFormat.lFlags
    
    Set ZBuffer = DD.CreateSurface(ddsd2)
    
    
    '- Attach Z-buffer to rendering surface
    Call BackBuffer.AddAttachedSurface(ZBuffer)
    
    m_bClearZ = True
    
    AttatchZBuffer = True
    Exit Function
errOut:
    AddLog "Erreur de Z Buffer Exit " + Err.Description + " " + CStr(Err.Number)
    AttatchZBuffer = False
End Function
Public Sub Clear()
 If ZBufferUse = True Then
 Device.Clear 1, CLR, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, BackGround, 1, 0
 Else
 Device.Clear 1, CLR, D3DCLEAR_TARGET, BackGround, 1, 0
 End If
End Sub

Private Sub DirectDrawInit(width, height, BPP)
 Windowed = False
 DDGuid = GetSetting("TrueVision", "CurrentMode", "DirectDrawGuid", "")
 Set DD = DirectX.DirectDrawCreate(DDGuid)
 DD.SetCooperativeLevel Form1.hwnd, DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
 DD.SetDisplayMode width, height, BPP, 0, DDSDM_DEFAULT
 Dim ddsd As DDSURFACEDESC2
 ddsd.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
 ddsd.ddsCaps.lCaps = DDSCAPS_3DDEVICE Or DDSCAPS_PRIMARYSURFACE Or DDSCAPS_COMPLEX Or DDSCAPS_FLIP
 ddsd.lBackBufferCount = 1
 Set Primary = DD.CreateSurface(ddsd)
 Dim Caps As DDSCAPS2
 Caps.lCaps = DDSCAPS_3DDEVICE Or DDSCAPS_BACKBUFFER
 Set BackBuffer = Primary.GetAttachedSurface(Caps)
 BackBuffer.SetFontTransparency True
 BackBuffer.GetSurfaceDesc BBDDSD
 SaveSetting "TrueVision", "CurrentMode", "DirectDrawGuid", DDGuid
End Sub
Private Sub DirectDrawWindowedInit(Handle)
   DDGuid = GetSetting("TrueVision", "CurrentMode", "DirectDrawGuid", "")
   Set DD = DirectX.DirectDrawCreate(DDGuid)
   Windowed = True
  DD.SetCooperativeLevel 0, DDSCL_NORMAL
  WindowResize
  
 

End Sub


Public Property Get DisplayFPS() As Boolean
  DisplayFPS = DisplayFPS2
End Property


Public Property Let DisplayFPS(Displ As Boolean)
  DisplayFPS2 = Displ
End Property

Private Sub Flip()
 If Windowed = True Then
 Dim re As RECT
  DirectX.GetWindowRect WindowHandle, re
  Primary.Blt re, BackBuffer, REC(0, 0, 0, 0), DDBLT_WAIT
 Else
 Primary.Flip Nothing, 0
 End If
End Sub


Public Property Get GetBackBuffer() As DirectDrawSurface7
 Set GetBackBuffer = BackBuffer
End Property

Sub GetCurrentVideoMode(width As Long, height As Long, BPP As Long)
  width = Val(GetSetting("TrueVision", "CurrentMode", "Width", "640"))
  height = Val(GetSetting("TrueVision", "CurrentMode", "Height", "480"))
  BPP = Val(GetSetting("TrueVision", "CurrentMode", "BPP", "16"))
End Sub

Function GetEngineVersion() As Single
  GetEngineVersion = ENGINE_VERSION
End Function

Function GetFPS() As Single
  GetFPS = FPS
End Function

'Public Property Get GetFormHwnd() As Long
'  GetFormHwnd = Form1.hWnd
'End Property


'Public Property Get GetFont() As IFont
' Set GetFont = Form1.Font
'End Property



Public Property Get GetPrimary() As DirectDrawSurface7
 Set GetPrimary = BackBuffer
End Property

Public Property Get GetDevice3D() As Direct3DDevice7
 Set GetDevice3D = Device
End Property

Public Property Get GetDirectDraw() As DirectDraw7
Set GetDirectDraw = DD
End Property
Public Property Get HardwareUse() As Boolean
 HardwareUse = Hardware
End Property
Public Property Let HardwareUse(Hardwared As Boolean)
 Hardware = Hardwared
End Property
Public Sub Init3DFullScreen(width As Long, height As Long, BPP As Integer)
  If Windowed = True Then
   Unload3D
  End If
  ShowCursor 0
  DirectDrawInit width, height, BPP
  SaveSetting "TrueVision", "CurrentMode", "Width", CStr(width)
  SaveSetting "TrueVision", "CurrentMode", "Height", CStr(height)
  SaveSetting "TrueVision", "CurrentMode", "BPP", CStr(BPP)
  InitDevice
End Sub
Public Sub Init2DFullScreen(width As Long, height As Long, BPP As Integer)
  ShowCursor 0
  DirectDrawInit width, height, BPP
End Sub


Sub Init3DWindowedMode(FormHandle As Integer)
 On Error GoTo errgest
   WindowHandle = FormHandle
   DirectDrawWindowedInit FormHandle
   WindowResize
   
   Exit Sub
errgest:
 MsgBox "Error in TrueVision WindowedMode", vbCritical, "ERROR !"
 
End Sub
Sub InitCurrentVideoMode()
  CurrentWidth = Val(GetSetting("TrueVision", "CurrentMode", "Width", "640"))
  CurrentHeight = Val(GetSetting("TrueVision", "CurrentMode", "Height", "480"))
  CurrentBPP = Val(GetSetting("TrueVision", "CurrentMode", "BPP", "16"))
  Init3DFullScreen CLng(CurrentWidth), CLng(CurrentHeight), CInt(CurrentBPP)
End Sub

Private Sub InitDevice()
 On Error GoTo initdevicegestError
 
 If Not D3DIM Is Nothing Then Set D3DIM = Nothing
 If Not Device Is Nothing Then Set Device = Nothing
 
  Set D3DIM = DD.GetDirect3D
  BackBuffer.GetSurfaceDesc BBDDSD
  Dim EnumDevice As Direct3DEnumDevices
  Set EnumDevice = D3DIM.GetDevicesEnum
 
  If Hardware = False Then
   DeviceGUID = "IID_IDirect3DRGBDevice"
   Memory = DDSCAPS_SYSTEMMEMORY
  Else
  DevGUID = GetSetting("TrueVision", "CurrentMode", "Direct3D GUID", "")
  If DevGUID = "" Then
    DeviceGUID = EnumDevice.GetGuid(EnumDevice.GetCount)
    SaveSetting "TrueVision", "CurrentMode", "Direct3D GUID", DeviceGUID
  Else
    DeviceGUID = DevGUID
  End If
  Memory = DDSCAPS_VIDEOMEMORY
 End If
 
 'last check !!
 If DeviceGUID = "IID_IDirect3DRGBDevice" Then
  Memory = DDSCAPS_SYSTEMMEMORY
 End If
 
 'AddLog "UseBuffer " + CStr(UseZBuffer)
 
attempt = "Zbuffer"
 If UseZBuffer = True Then
   AttatchZBuffer
 End If
 
attempt = "Device"
 Set Device = D3DIM.CreateDevice(DeviceGUID, BackBuffer)

 ViewPort.lWidth = BBDDSD.lWidth
 ViewPort.lHeight = BBDDSD.lHeight
 ViewPort.lX = 0
 ViewPort.lY = 0
 ViewPort.MinZ = 0#
 ViewPort.maxZ = 1#
 
 attempt = "Device.Target"
 Device.SetRenderTarget BackBuffer
 Device.SetViewport ViewPort

  With CLR(0)
   .x1 = ViewPort.lX
   .Y1 = ViewPort.lY
   .X2 = ViewPort.lWidth
   .y2 = ViewPort.lHeight
  End With
  
  DirectX.ViewMatrix ViewMatrix, Vector(0, 0, -20), Vector(0, 0, 0), Vector(0, 1, 0), 0
  DirectX.ProjectionMatrix ProjectionMatrix, 1, 4000, 3.1415 / 2
  DirectX.IdentityMatrix WorldMatrix
  FOV = 90
  FarPlane = 4000
  
  Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, ProjectionMatrix
  Device.SetTransform D3DTRANSFORMSTATE_VIEW, ViewMatrix
  Device.SetTransform D3DTRANSFORMSTATE_WORLD, WorldMatrix
  Device.SetRenderState D3DRENDERSTATE_LIGHTING, False
 Device.SetRenderState D3DRENDERSTATE_AMBIENT, DirectX.CreateColorRGBA(1, 1, 1, 1)
 Device.SetRenderState D3DRENDERSTATE_SHADEMODE, D3DSHADE_GOURAUD
 Device.SetRenderState D3DRENDERSTATE_FILLMODE, D3DFILL_SOLID
 Device.SetTextureStageState 0, D3DTSS_MINFILTER, 2
 Device.SetTextureStageState 0, D3DTSS_MAGFILTER, 2
  OldTime = DirectX.TickCount
  OldFPS = DirectX.TickCount
  SystemFrame = 50
  BackBuffer.BltColorFill REC(0, 0, 0, 0), 0
  BackBuffer.SetForeColor RGB(256, 0, 0)
 Exit Sub
initdevicegestError:
 Unload3D
 MsgBox "Init Device Error " + Err.Description + " " + CStr(Err.Number) + " " + attempt
 Exit Sub
 
End Sub

Public Sub OpenPAKFile(filename As String)
If PakEnable = False Then
  On Error GoTo fin
 Open filename For Binary Lock Read As 80  '80 will be used for all PAK operations
  Get #80, , PakHeader
  Seek #80, PakHeader.dirofs + 1 '+1 because c++ byte count is 0-based
  Get #80, , PakFiles()
  For i = 0 To 4096
   If Len(PakFiles(i).named) < 3 Then Exit For
   'Remove Chr(0)
   PakFiles(i).named = Trim(Left(PakFiles(i).named, InStr(PakFiles(i).named, Chr(0)) - 1))
  Next i
 
 NBFileInPak = Int(PakHeader.dirlen / Len(PakFiles(1)))
 
 
 PakEnable = True
  AddLog "Pak " + filename + " opened :" + CStr(NBFileInPak) + " files"
 Exit Sub
 End If
fin:
 AddLog "Error loading PAK files " + Err.Description
 PakEnable = False
End Sub

Public Sub RenderToScreen()

 Device.SetTransform D3DTRANSFORMSTATE_VIEW, ViewMatrix
 SystemFrame = DirectX.TickCount - OldTime
 OldTime = DirectX.TickCount
 If DisplayFPS2 = True Then
   UpdateFPS
   BackBuffer.DrawText 0, 0, CStr(Int(FPS)) + " FPS", False
 End If
 Flip
 
End Sub




Sub SetSearchDirectory(Path As String)
  If Right(Path, 1) <> "\" Then Path = Path + "\"
  ChDrive Left(Path, 1)
  ChDir Path
  AppPath = Path
End Sub
Function ShowDriverWindow() As Boolean
   'If the user calls this sub during the game, shut down the engine
   If Not Device Is Nothing Then
    Unload3D
   End If
   Form2.Show 1
   If Form2.Commit = True Then
    ShowDriverWindow = True
    
    'the engine uses registered values.
    SaveSetting "TrueVision", "CurrentMode", "Width", CStr(Form2.MWidth)
    SaveSetting "TrueVision", "CurrentMode", "Height", CStr(Form2.MHeight)
    SaveSetting "TrueVision", "CurrentMode", "BPP", CStr(Form2.MBPP)
    SaveSetting "TrueVision", "CurrentMode", "DirectDrawGuid", Form2.DirectDrawGuid
    SaveSetting "TrueVision", "CurrentMode", "Direct3D GUID", Form2.Direct3DGuid
   Else
    'the user has clicked on Cancel
    ShowDriverWindow = False
   End If
   Unload Form2
   
   
   
End Function

Public Property Get TimeElapsed() As Long
  TimeElapsed = SystemFrame
End Property

Public Sub Unload3D()
 On Error Resume Next
 Close
  ShowCursor 1
 Set Primary = Nothing
 Set BackBuffer = Nothing
 Set Device = Nothing
 Set D3DIM = Nothing
 If Windowed = False Then
  DD.RestoreDisplayMode
  DD.SetCooperativeLevel 0, DDSCL_NORMAL
  Unload Form1
 Else
  Set Clipper = Nothing
 End If
 Set DD = Nothing
 On Error GoTo 0
End Sub

Private Sub UpdateFPS()

 NBImage = NBImage + 1
  
 If DirectX.TickCount - OldFPS > 1000 Then
   FPS = NBImage / ((DirectX.TickCount - OldFPS) / 1000)
   NBImage = 0
   OldFPS = DirectX.TickCount
 End If
End Sub

Public Property Get UseZBuffer() As Boolean
 UseZBuffer = ZBufferUse
End Property

Public Property Let UseZBuffer(buffer As Boolean)
 ZBufferUse = True
End Property
Public Sub WindowResize()
On Error GoTo error
If Not Primary Is Nothing Then Set Primary = Nothing
If Not BackBuffer Is Nothing Then Set BackBuffer = Nothing
  Dim r As RECT
  DirectX.GetWindowRect WindowHandle, r
  wid = r.Right - r.Left
  hei = r.Bottom - r.Top
  Dim ddsd As DDSURFACEDESC2
   ddsd.lFlags = DDSD_CAPS
   ddsd.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE
   'ddsd.lBackBufferCount = 1
 attempt = "Primary"
 Set Primary = DD.CreateSurface(ddsd)
 
 
 Dim ddsd2 As DDSURFACEDESC2
 ddsd2.lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT
 ddsd2.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN Or DDSCAPS_3DDEVICE
 ddsd2.lWidth = wid
 ddsd2.lHeight = hei
 Set Clipper = DD.CreateClipper(0)
 Clipper.SetHWnd WindowHandle
 attempt = "Backbuffer"
 Set BackBuffer = DD.CreateSurface(ddsd2)
 
 BackBuffer.SetFontTransparency True
 BackBuffer.SetClipper Clipper
 InitDevice
Exit Sub
error:
 AddLog "Erreur in WindowResize " + Err.Description + " " + CStr(Err.Number)
 Resume Next
 
 
End Sub


Private Sub Class_Initialize()
 ZBufferUse = True
 Hardware = True

 On Error GoTo ErrorType
 
Exit Sub
ErrorType:
ErrorGest
  
End Sub

Private Sub Class_Terminate()

Unload3D
End Sub


