Attribute VB_Name = "TV7"
' True Vision 7 Module v 1. bt
' Sylvain Dupont - Le coin des dveloppeur 3D
'                  The corner of the developers of games 3d
'
'
'
Public DirectX As New DirectX7

Public DD As DirectDraw7
Public D3D As Direct3D7
Public Device As Direct3DDevice7
Public Primary As DirectDrawSurface7
Public BackBuffer As DirectDrawSurface7
Public Viewport As D3DVIEWPORT7
Public EnumDevice As Direct3DEnumDevices
Public ZBuffer As DirectDrawSurface7

Public DS As DirectSound
Public DSB3D(30) As DirectSound3DBuffer
Public DSB(30) As DirectSound

Public Driver(10) As D3DDRIVER, NumD3DDriver As Integer
Public ModeVideo(30) As DDMODEVIDEO, NumModeVideo As Integer

Type DDMODEVIDEO
  Width As Integer
  Height As Integer
  Depth As Integer
End Type

Type D3DDRIVER
  GUID As String
  Name As String
  Description As String
End Type

Type TVDESC
  GUID As String
  ModeVideoWidth As Integer
  ModeVideoHeight As Integer
  ModeVideoDepth As Integer
  RealLighting As Boolean
  Sound As Boolean
  UseZBuffer As Boolean
End Type
Public Sub CloseTV()
 Set DirectX = Nothing
 Set DD = Nothing
 Set D3D = Nothing
 Set Device = Nothing
 Set ZBuffer = Nothing
 Set Primary = Nothing
 Set BackBuffer = Nothing
End Sub

Public Sub GetModesVideo()
 If DD Is Nothing Then
  Set DD = DirectX.DirectDrawCreate("")
 End If
 Dim EDM As DirectDrawEnumModes
 Dim ddsd As DDSURFACEDESC2
 
 Set EDM = DD.GetDisplayModesEnum(DDEDM_DEFAULT, ddsd)
NumModeVideo = EDM.GetCount
For i = 1 To EDM.GetCount()
 EDM.GetItem i, ddsd
 ModeVideo(i).Depth = ddsd.ddpfPixelFormat.lAlphaBitDepth
 ModeVideo(i).Height = ddsd.lHeight
 ModeVideo(i).Width = ddsd.lWidth
Next i
 
End Sub


Public Sub InitTV(Form As Form, Desc As TVDESC)
 If DD Is Nothing Then Set DD = DirectX.DirectDrawCreate("")
 If D3D Is Nothing Then Set D3D = DD.GetDirect3D
 DD.SetCooperativeLevel Form.hWnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE Or DDSCL_ALLOWREBOOT
 DD.SetDisplayMode Desc.ModeVideoWidth, Desc.ModeVideoHeight, Desc.ModeVideoDepth
 
 Dim ddsd As DDSURFACEDESC2
 ddsd.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
 ddsd.lBackBufferCount = 1
 ddsd.ddscaps.lCaps = DDSCAPS_3DDEVICE Or DDSCAPS_PRIMARYSURFACE Or DDSCAPS_COMPLEX Or DDSCAPS_FLIP
 Set Primary = DD.CreateSurface(ddsd)
 
 Dim ddscaps As DDSCAPS2
 ddscaps.lCaps = DDSCAPS_BACKBUFFER
 Set BackBuffer = Primary.GetAttachedSurface(ddscaps)
 
 
 Set Device = D3D.CreateDevice(Desc.GUID, BackBuffer)
 
 Viewport.lX = 0
 Viewport.lY = 0
 Viewport.lHeight = Desc.ModeVideoHeight
 Viewport.lWidth = Desc.ModeVideoWidth
 Viewport.minz = 0
 Viewport.maxz = 1
 
 Device.SetViewport Viewport
 
 If Desc.UseZBuffer = True Then x = AttatchZBuffer()
End Sub
Function AttatchZBuffer() As Boolean
    On Local Error GoTo errOut
            
    
    Dim hr As Integer
    Dim ddsZBuff  As DirectDrawSurface7
    Dim ddsd As DDSURFACEDESC2
    Dim ddsdZ As DDSURFACEDESC2
    
    Dim l As Long
    Dim i As Long

 
    Dim fenum As Direct3DEnumPixelFormats
    Set fenum = D3D.GetEnumZBufferFormats(DriverGUID)
    l = fenum.GetCount()
    
    If l = 0 Then
        AttatchZBuffer = True
       Exit Function
    End If
    
    For i = 1 To l
        Call fenum.GetItem(i, ddsdZ.ddpfPixelFormat)
        If ddsdZ.ddpfPixelFormat.lZBufferBitDepth = 16 Then Exit For
    Next
    

                           
    ddsdZ.lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT Or DDSD_PIXELFORMAT
    ddsdZ.ddscaps.lCaps = DDSCAPS_ZBUFFER
    ddsdZ.lWidth = Viewport.lWidth
    ddsdZ.lHeight = Viewport.lHeight
    Set ZBuffer = DD.CreateSurface(ddsdZ)
    
    BackBuffer.AddAttachedSurface ZBuffer
    
    AttatchZBuffer = True
    Exit Function
errOut:
    AttatchZBuffer = False
End Function



